/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torEvent_h__
#define __torEvent_h__ (1)

#include "torPlatform.h"

#include "torInstanceManager.h"

namespace tor 
{

    // Common base class for all events
    class TOR_EXT_DEF Event 
    {
    public:
        Event();
        virtual ~Event();

        // Determines if the run-time type of e is 'Event'.
        // Since all events inherit from the Event class, 
        // this function always returns true.
        static bool isTypeOf(const Event* e);

        // Called when the event is received, before the transition is executed.
        virtual void received();

        InstanceManager::ObjectId m_receiver;
    };

    // Common base class for all internal events that are sent in a TOR-based application
    // (i.e. events other than the application events).
    class TOR_EXT_DEF InternalEvent : public Event {
    public:
        static bool isTypeOf(const Event* e);
    };
}

#endif

