# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportParameters { elmt headingLevel } {

  if { [catch { set parameterList [u2::GetEntities $elmt Parameter] } ] } { return }

  if { [llength $parameterList] == 0 } { return } ;# end_if no parameter in element to report

  if { $headingLevel != 0 } {

    html_paragraph ""
    html_heading $headingLevel "" "Parameters"

  };#end_if heading to add

  foreach parameter $parameterList {

    # Create parameter report heading
    html_bullet_start

    # Add the parameter's direction to the heading
    set paramDirection [GetDirection $parameter]

    if { $paramDirection != "" } { html_print "$paramDirection " }

    # Add the parameter's name to the heading
    html_print [GetElementName $parameter]

    # Does the parameter have a type
    html_print [GetElementType $parameter]

    html_bullet_end

#    html_list_start
#    ReportProperties $parameter 0
#    html_list_end

  };#end_foreach parameter

};#end_proc ReportParameters
