# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#########################################################################################
#  										   	#		 		
#	Name of Addin : XMI Export Addin for Tau G2					#
#	File Name     :	ModelAccess.tcl							#
#	Date          : 05-AUGUST-2006							#
#       										#
#	Description   : This is the main file to access all the elements in the model	# 
#			of IBM Rational Tau.  						#
#			 								#
# 											#
######################################################################################### 

 
source [std::GetInstallationDirectory]/addins/XMIExport/Script/presentationElements.tcl
source [std::GetInstallationDirectory]/addins/XMIExport/Script/modelElementProperties.tcl


# Cleanup the Output Window
OutputTab clear Script
namespace import u2::*

global DataType_list


#Declaring Global Variables

global isPack
global isOperation
global isActor
 
#Defining all variables

set isPack "Class Diagram"
set isOperation Operation

# These procedures are for extracing information of Sequence Diagram

proc ForWriting_Implement {selection} {
global file
global class
global id_selection
set id_selection ""
global isOperation
set isOperation ""

	switch -- [u2::GetMetaClassName $selection] {

		"Interaction" {
			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
			
			set fail [catch {MapRole $selection Owner ForOwner} error]
			if {$fail} {
		 		  Report $selection "Catch Error" $error
			}

			
		 set fail [catch {MapRole $id_selection AppliedStereotypeInstance Fortype} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			if {$isOperation == "UseCase"} {
            			WritinginXMI_Collaboration $selection
			}

			set fail [catch {MapRole $selection Signature ForWriting} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			
			set fail [catch {MapRole $selection Signature ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Att} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			
			}
		"SimpleStateMachine" {
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			
			set fail [catch {MapRole $selection Signature ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Att} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			
			set fail [catch {MapRole $selection Signature ForWriting} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
			

			}
   		"ActivityImplementation" {

                        set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			
			set fail [catch {MapRole $selection Signature ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Att} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
			 
			
			set fail [catch {MapRole $selection Signature ForWriting} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $selection Variable ForWriting_Class} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
                   
		}


	}



return 1
}

proc ForActionNode {selection} {

switch -- [u2::GetMetaClassName $selection] {
"ActionNode" {
		MapRole $selection Activity ForWriting
      		}
	}

return 1
}




proc Implement {selection} {
global file

	
	set fail [catch {set type "[u2::GetMetaClassName $selection]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



	switch -- [u2::GetMetaClassName $selection] {

		"Interaction" {


            	WritinginXMI_Collaboration $selection

			}
		"SimpleStateMachine" {

		WritinginXMI_Statemachine $selection $type
          				
			}
   		"ActivityImplementation" {


                  WritinginXMI_Statemachine $selection $type  
                   
		}


	}

return 1
}

proc ForSequenceDiagram {selection} { 
 
  set fail [catch {MapRole $selection InlineMethod Implement} error]
  if {$fail} {
 	  Report $selection "Catch Error" $error
  }

	
}

# This accesses the constraints of the elements

proc ForConstraints {selection} {

global constraint
set constraint ""
	
	set fail [catch {MapRole $selection InformalConstraint GetConstraint} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



	WritinginXMI_Constraint $selection $constraint
 
  return 1
}

proc ForDependency {selection} {

global client
global supplier
global owner
global id_selection
global Export_Rose
global element_id
set element_id [u2::GetValue $selection Guid]

global element_text
set element_text ""
 


set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


Diagram_Text $id_selection


		
		set fail [catch {MapRole $selection Client ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}



		set client $owner
set clt $id_selection
		
		set fail [catch {MapRole $selection Supplier ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


		set supplier $owner

if {$Export_Rose == 1} {
            WritinginXMI_Dep $selection $client $supplier $element_text

} else {

if {[u2::GetMetaClassName $clt]!="Collaboration" && [u2::GetMetaClassName $id_selection]!="Collaboration" } {
            WritinginXMI_Dep $selection $client $supplier $element_text
  }
}

  return 1
}


# Procedure which checks whether a class has an implementation and then write it to XMI; also for writing dependency to XMI

proc ForRealize {selection} {
global Export_Rose

switch -- [u2::GetMetaClassName $selection] {
	"Class" {

		if {$Export_Rose == 1} {
			
			set fail [catch {MapRole $selection Generalization CheckRealize} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}



			}
		}
	}
	
	set fail [catch {MapRole $selection ClientDependency ForDependency} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


return 1
}

proc CheckRealize {selection} {
global class
global isRealize

		
		set fail [catch {MapRole $selection Parent ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}



	if {$class == "Interface"} {

			set isRealize 1
			WritinginXMI_Abstract $selection
		}


	return 1

}



proc ForClass {selection} {
global isPack
global isOperation
global isActor
global ClassType

switch -- [u2::GetValue $selection Name] {
	"packageDiagram" {
		set isPack "Package Diagram"
	}
	"usecase" {
		set isOperation UseCase
                set ClassType "UseCase"
	}
	"interaction" {
		set isOperation interaction
	}
	"activity" {
		set isOperation activity
	}
	"actor" {
		set isActor Actor
                set ClassType "Actor"
	}
	
}

return 1
}

proc Fortype {selection} {
	
	set fail [catch {MapRole $selection Type ForClass} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

		

return 1
}


# This procedure is to write Performance Elements to XMI

proc ForPerfElelements {selection} {
set name ""
set agg ""
set visible ""
set changeable ""
set navigable ""
set scope ""

global PerLineGuid
global Export_Rose

if {$Export_Rose==1} { 
#output "[u2::GetValue $selection Name]"
}
	WritinginXMI_PerfElements $selection $name $agg $visible $changeable $navigable $scope $PerLineGuid
	return 1
}



# This procedure calls the procedure to write Association Ends after swapping the aggeration property

proc WriteAssociationEnds {list} {

set agg [lindex $list 12]
set name [lindex $list 0]
set visible [lindex $list 1]
set changeable [lindex $list 2]
set navigable [lindex $list 3]
set scope [lindex $list 5]
set selection [lindex $list 6]
set owner [lindex $list 7]

 
 
WritinginXMI_AssocEnds $selection $name $agg $visible $changeable $navigable $scope $owner

set agg [lindex $list 4]
set name [lindex $list 8]
set visible [lindex $list 9]
set changeable [lindex $list 10]
set navigable [lindex $list 11]
set scope [lindex $list 13]
set selection [lindex $list 14]
set owner [lindex $list 15]

  
WritinginXMI_AssocEnds $selection $name $agg $visible $changeable $navigable $scope $owner

}





# This procedure is to extract Association Ends and store their properties in a list. We will later swap the aggergation properties of the roles


proc ForAssociationEnds {selection} {
global owner
global class
global assoc_end_properties
global flag
global Export_Rose

set fail [catch {set name "[u2::GetValue $selection Name]"} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

if {[u2::GetValue $selection Derived]=="true"} { 
	set Derived "/"
        set name $Derived$name
} 

lappend assoc_end_properties $name

set visible [getVisibility $selection]
lappend assoc_end_properties $visible

set changeable [getchangeability $selection]
lappend assoc_end_properties $changeable

set navigable [u2::GetValue $selection IsNavigable]
lappend assoc_end_properties $navigable

set agg [getAggregation $selection]
lappend assoc_end_properties $agg

set scope [getscope $selection]
lappend assoc_end_properties $scope

lappend assoc_end_properties $selection

	
	set fail [catch {MapRole $selection Type ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


if {$class == "Collaboration" && $Export_Rose == 0} {
	set flag 1
}
lappend assoc_end_properties $owner


 
	return 1

}


# This procedure is to access Performance properties

proc Traverse_Perf {selection} {
global id_selection
global Export_Rose
global flag
set flag 0
  

	switch -- [u2::GetMetaClassName $selection] {
       
	"Performance" {
 
	      if {$Export_Rose==1} { 
	WarningMesgPath		 
	 Report $selection "Warning" "Creating an Association stereotyped as <<performance>>" 
	       }
 
		
		set fail [catch {MapRole $selection Source ForPerfElelements} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


		if {$Export_Rose==1} { 
			#output " to "
		}
			
			set fail [catch {MapRole $selection Target ForPerfElelements} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


		}

	"Association" {
 
 
		global assoc_end_properties
		set assoc_end_properties ""
		
		set fail [catch {MapRole $selection AssociationEnd ForAssociationEnds} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$flag == 0 && $assoc_end_properties!= ""} {
		      set fail [catch {WriteAssociationEnds $assoc_end_properties} error]
		      if {$fail} {
		              Report $selection "Error" "Association is corrupted. Association end is not exported"
                      }
			
		}
	 }
	}

  return 1
}


# This procedure is to access diagrams properties

proc Traverse_Diagram {selection} {

	
	set fail [catch {MapRole $selection DiagramElement ForPresElements} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


  return 1
}


proc Dia {selection} {

	
	set fail [catch {MapRole $selection DiagramElement ForCommentSymbol} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	WritinginXMI_Diagram $selection

	return 1

}


# This calls the procedure to export Text and Comment Symbols and Association line which is not present in model view to XMI

proc ForExtension {selection} {

		
	set fail [catch {MapRole $selection DiagramElement ForExtensionLine} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

return 1
	
}


# This calls the procedure to export Text and Comment Symbols and Association line which is not present in model view to XMI for a class

proc ForAssociation_Class {selection} {

switch -- [u2::GetMetaClassName $selection] {

		"Class" {

				
			set fail [catch {MapRole $selection Diagram ForDiagam_class} error]
			if {$fail} {
				  Report $selection "Catch Error" $error
			}
	

			}
	}

return 1
	
}



proc ForDiagam_class {selection} {

	
	set fail [catch {MapRole $selection DiagramElement ForExtensionLine} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

return 1
}




# This calls the procedure to export Performance and Association to XMI

proc ForPerfomance {selection} {


 
# Code Review
set metaClassName [u2::GetMetaClassName $selection] 	
 
if { $metaClassName == "Performance" || $metaClassName == "Association"} {

	WritinginXMI_Perf $selection 
} else {
	if {[u2::GetMetaClassName $selection] == "Class"} {
		
		
		set fail [catch {MapRole $selection Association ForPerfomance} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

	}
}

return 1
	
}

# This calls the procedure to export Generalization to XMI

proc Gen {selection} {
global class
global Export_Rose
	
	set fail [catch {MapRole $selection Owner ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	if {$class == "Class" && $Export_Rose == 1} {

		
		set fail [catch {MapRole $selection Parent ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


	if {$class != "Interface"} {
			WritinginXMI_Gen $selection
		}

	} else {

		WritinginXMI_Gen $selection
	}

	return 1

}


# This is for extracting datatypes associated with attributes
proc PrintDefinition {selection} {
global name
global Data_id
global DataType_list
set Flag 0
global Export_Rose

global Class_xmiid

# Rashid
set Class_xmiid ""

set DataType_list ""
 
# Rashid 
set name ""

   

if {$Export_Rose == 1} {
	if { [u2::GetMetaClassName $selection] == "AttributeTemplateParameter"} {

		WritingOperationPara $selection
	}
}
if {[u2::GetMetaClassName $selection] == "AttributeTemplateParameter" && $Export_Rose == 1} {
		
		set fail [catch {MapRole $selection Type ForName} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}



                foreach item $DataType_list { 
                	if {$item==$name} { set Flag 1 }
                }
 
                if {$Flag==0} {
                          lappend DataType_list $name
                           WritinginXMI_Datatype $selection $name $Data_id
                }    

}

# Code Review
set metaClassName [u2::GetMetaClassName $selection] 	
       
if {$metaClassName == "Attribute" || $metaClassName== "Parameter" || $metaClassName=="Syntype"} {
   		      	
			set fail [catch {MapRole $selection Type ForName} error]
			if {$fail} {
		 		  Report $selection "Catch Error" $error
			}
	
                        foreach item $DataType_list { 
                           if {$item==$name} { set Flag 1 }
                        }

#output "\n ^^^^^^^^^^^^^^^^^^    $Class_xmiid"
			 
#&& [string range $Class_xmiid  0 10] == "@Predefined"			 			
 
                        if {$Flag==0} {
                            lappend DataType_list $name
                            WritinginXMI_Datatype $selection $name $Data_id
                        }         
            }

}


# Procedure to write parameters of operations

proc WritingOperationPara {selection} {

global Data_id
global file 
global OpName 
 
global IntValue
global CharValue
global OpName 

set IntValue ""
set CharValue ""
global Export_Rose


                    	
			set fail [catch {MapRole $selection Type ForName} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


                     	 
			set fail [catch {set ParName [u2::GetValue $selection Name]} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


   			set ParDir "in"
 
	switch -- [u2::GetMetaClassName $selection] {

		"Parameter" {
                    
		    set fail [catch {set ParDir [u2::GetValue $selection Direction]} error]
		    if {$fail} {
		 	  Report $selection "Catch Error" $error
		    }


	    
                     		if {$ParDir=="DkNone"} {
					if {$Export_Rose == 1} {
                        		set ParDir "inout"
					}
                     		} else {
                      	 	 	set ParDir "return"
                        		set Dot "." 
					if {$Export_Rose == 1} {
                        		set ParName $OpName$Dot$ParDir
					}
                         
                     		}	
			}
		}

                     set text "<UML:"
                     append text "Parameter xmi.id=\"$selection\""
                     append text " name=\"$ParName\""
                     append text " kind=\"$ParDir\"" 
                     append text " type=\"$Data_id\">"
                   
                     puts $file $text


 
	switch -- [u2::GetMetaClassName $selection] {

		"Parameter" {
                     if {$ParDir=="inout"} {
                          
			set fail [catch {MapRole $selection Type ForName} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

                          
			  set fail [catch {MapRole $selection DefaultValue ForDefault} error]
			  if {$fail} {
			 	  Report $selection "Catch Error" $error
			   }



                          set text "<UML:"
                	  append text "Parameter.defaultValue> "
			  puts $file $text
                           
                             set text "<UML:Expression body=\"$IntValue\"/>"
                             puts $file $text   
        
                          set text "</UML:"
			  append text "Parameter.defaultValue> "
           		  puts $file $text
                          set IntValue ""
                     	 } 
			}
		}
                         
 

                     set text "</UML:"
                     append text "Parameter > "
                     puts $file $text


  return 1
			
}

proc StMachineDefinition {selection} {


global isOperation
set isOperation ""
global id_selection
set id_selection ""



		switch -- [u2::GetMetaClassName $selection] {

		"StateMachine" {

			
			set fail [catch {MapRole $selection Owner ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}



			if {[u2::GetMetaClassName $id_selection] != "State"} {
	
				ForSequenceDiagram $selection
			}
		}

		"Operation" {

			
		set fail [catch {MapRole $selection AppliedStereotypeInstance Fortype} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$isOperation != "UseCase"} {


				if {$isOperation == "activity"} {
					set id_selection ""
					
			set fail [catch {MapRole $selection ActivityContainer ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


					if {$id_selection != ""} {

						if {[u2::GetMetaClassName $id_selection] != "ActionNode"} {

								ForSequenceDiagram $selection
						}
					} 

				} 
			} 
		}


	}


}



# Procedure to write sterotype for the elements


proc StereoDefinition {selection} {

global Export_Rose
global Stereo_id
global owner
global id_selection
global class
global Stereotype_Name
global Stereotype_count
set Stereotype_Name ""
set Stereotype_count 0


set fail [catch {set test "[u2::GetMetaClassName $selection]"} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


if {$test == "StateSymbol"} {

set fail [catch {MapRole $selection ModelElement ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set test $class

}

#  TLOG#28837 : Unable to identify "operation reference"(exported as interface in xmi file)
# ON 11 _MAY_2007

if {$test == "Interface"} {

 			set Stereotype_Name ""
			set Stereotype_count 0
			MapRole $selection StereotypeInstance ForInstance

			if {$Stereotype_Name != ""} {
				set guid [u2::GetValue $selection Guid]
				set base "Interface"
				Writing_Stereotype $selection $Stereotype_Name $guid $base
			}
}	
#


if {$test == "MultiState"} {
			
			set fail [catch {set guid [u2::GetValue $id_selection Guid]} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			set base "$test"
			set Stereotype_Name ""
 			
		set fail [catch {MapRole $id_selection StereotypeInstance ForInstance} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}


			if {$Stereotype_Name != ""} {

			Writing_Stereotype $id_selection $Stereotype_Name $guid $base
			}
}

if {$test == "ActivityDecisionNode"} {
			
			set fail [catch {set guid [u2::GetValue $selection Guid]} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			set base "state"
			set Stereotype_Name ""
 			
		set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


			if {$Stereotype_Name != ""} {
			Writing_Stereotype $selection $Stereotype_Name $guid $base
			}
}


if {$test == "ActionNode"} {
global subactivity 
set subactivity 0

set fail [catch {MapRole $selection Activity ForActivity} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

			if {$subactivity == 0} {
				set base "state"
			} else {
				set base "Activity"
			}
			
			set fail [catch {set guid [u2::GetValue $selection Guid]} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			set Stereotype_Name ""
 			
		set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

			if {$Stereotype_Name != ""} {
			Writing_Stereotype $selection $Stereotype_Name $guid $base
			}
}

 

if {$test == "Class" || $test == "State"} {
			
			set fail [catch {set guid [u2::GetValue $selection Guid]} error]
			if {$fail} {
		 		  Report $selection "Catch Error" $error
			}



			set base "$test"
			set Stereotype_Name ""
 			
		set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}



 
			if {$Stereotype_Name != ""} {
          			Writing_Stereotype $selection $Stereotype_Name $guid $base
			}
}


if {$Export_Rose == 1} {
if {$test == "Collaboration" || $test == "Signal" || $test ==  "StateMachine" || $test ==  "Artifact" || $test ==  "Timer" || $test ==  "Stereotype" || $test ==  "Choice"} {
			
	
	set fail [catch {set Stereotype_Name [u2::GetMetaClassName $selection]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	
	set Stereotype_count 1
	
	set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set base "Class"
	set id "St."
	append id "$Stereo_id"
	
	set fail [catch {set guid [u2::GetValue $selection Guid]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	Writing_Stereotype $id $Stereotype_Name $guid $base
	set Stereo_id [expr $Stereo_id + 1]

	# Code Review
        set metaClassName [u2::GetMetaClassName $selection] 	

	if {$metaClassName == "Collaboration" || $metaClassName == "Stereotype" || $metaClassName == "Artifact" } {

				
			set fail [catch {MapRole $selection Attribute ForStereotype} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}



			} else {
				
			set fail [catch {MapRole $selection Parameter ForStereotype} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}


	
		}


	}
}
if {$test == "Operation" } {

	
	set fail [catch {MapRole $selection InlineMethod ForDiagramStereo} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	global isOperation
	set isOperation "operation"

	
	set fail [catch {MapRole $selection AppliedStereotypeInstance Fortype} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	if {$isOperation == "operation"} {
	set Stereotype_Name "operation" 
	set Stereotype_count 1
	}

	set id "St."
	append id "$Stereo_id"
	
	set fail [catch {set guid [u2::GetValue $selection Guid]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set base "class"


set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

	
if {$class == "Class" || $class == "Interface" || $class == "Artifact"} {
	set base "operation"
	set Stereotype_Name "" 
	set Stereotype_count 0

}

	
	set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	if {$Stereotype_Name != ""} {
		if {$Export_Rose == 1 || $Stereotype_Name != "activity"} {
	
		Writing_Stereotype $id $Stereotype_Name $guid $base
		set Stereo_id [expr $Stereo_id + 1]
		}
	}
	


}


if {$test == "Attribute" } {


	
	set base $test

	global isActor
	set isActor ""
	
	set fail [catch {MapRole $selection AppliedStereotypeInstance Fortype} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	if {$isActor == "Actor"} {
	set class ""

		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
 			  Report $selection "Catch Error" $error
		}


		if {$class == "Class" || $class == "ActivityImplementation"} {
	
		set base "Class"
	 
		 

		}
	}
		set id "St."
		append id "$Stereo_id"
		
set fail [catch {set guid [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}




		
set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}




		if {$Stereotype_Name != ""} {
		Writing_Stereotype $id $Stereotype_Name $guid $base
		set Stereo_id [expr $Stereo_id + 1]
		}
		
	

}

if {$test == "DataType" } {
global isEnumeration
set isEnumeration 0

        set Stereotype_Name "primitive"
        set type "Primitive"
	set base "Class"
	set id "St."
	append id "$Stereo_id"
	
set fail [catch {set guid [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}




	
set fail [catch {MapRole $selection Literal Enumeration} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}



	if {$isEnumeration==1} {
	         set Stereotype_Name "enumeration"  
         	 set type "Enumeration"       
 	        }
 	set Stereotype_count 1
	
set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}




 

	Writing_Stereotype $id $Stereotype_Name $guid $base
	set Stereo_id [expr $Stereo_id + 1]
	
set fail [catch {MapRole $selection Literal ForStereotype} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}



}

if {$test == "StateMachine" } {
	
	set fail [catch {MapRole $selection InlineMethod ForDiagramStereo} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



}

}

 


proc ForDiagramStereo {selection} {


if {[u2::GetMetaClassName $selection] == "ActivityImplementation"} {

	
	set fail [catch {MapRole $selection Node ForPresElementStereo} error]
	if {$fail} {
 	  Report $selection "Catch Error" $error
	}



}

set fail [catch {MapRole $selection Diagram ForDiagramElementStereo} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}



return 1
}

proc ForDiagramElementStereo {selection} {

set fail [catch {MapRole $selection DiagramElement ForPresElementStereo} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}




return 1
}

proc ForPresElementStereo {selection} {

StereoDefinition $selection

return 1
}

# This procedure traverses for the diagramelements of a diagram for association line

proc ForAssociationAttributes {selection} {

	
	set fail [catch {MapRole $selection DiagramElement ForAssociationAttributes_1} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}




return 1
}


proc usecaseDefinition {selection} {

global isOperation
global id_selection
global class
global file
global owner


global package_id


	if {[u2::GetMetaClassName $selection] == "Operation" } {
		
		set isOperation "Class"
		
		set fail [catch {MapRole $selection AppliedStereotypeInstance Fortype} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		

		if {$isOperation == "UseCase"} {

				
			set fail [catch {MapRole $selection Owner ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {[u2::GetMetaClassName $id_selection] != "Package"} {

				set done 0
				while {$done == 0} {
					set class ""
					
				set fail [catch {MapRole $id_selection Owner ForOwner} error]
					if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					}


				if {$class == "Package" || $class == "Session" || $class == ""} {
						set done 1
						}
				
					}

				if {$owner == $package_id} {

 WarningMesgPath
Report $selection "Warning" "UseCase ([u2::GetValue $selection Name]) is moved up to enclosing package"

						set namespace $owner
						WritinginXMIUseCase $selection $namespace


				}	


			}

		} else {

			set id_selection $selection
			set done 0
			while {$done == 0} {
				set class ""
				
				set fail [catch {MapRole $id_selection Owner ForOwner} error]
				if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				}


				if {$class == "Package" || $class == "Session" || $class == ""} {
					set done 1
					}
				
				}

			if {$owner == $package_id} {
				if {$isOperation == "activity"} {
					set id_selection ""
					
			set fail [catch {MapRole $selection ActivityContainer ForOwner} error]
			if {$fail} {
				 	  Report $selection "Catch Error" $error
			}


					if {$id_selection != ""} {

				if {[u2::GetMetaClassName $id_selection] != "ActionNode"} {

								ForSequenceDiagram $selection
							}
					} else {
							ForSequenceDiagram $selection
					}

				} else {

						ForSequenceDiagram $selection
				}


			}
				


		}

	}


}





# This traverses the different elements by calling corresponding procedures

proc Traverse {selection} {
global file
global isRealize
global extended_text
global Stereo_id
global IntValue
global CharValue
global OpName 
global class
global Stereotype_count
global Stereotype_Name
set Stereotype_Name ""
set isRealize 0
set IntValue ""
global Export_Rose
global Multiplicity_id
global lower
global upper
global open
global operator
set lower ""
set upper ""
set open ""
set operator ""
global access_comment
global package_id
 


	switch -- [u2::GetMetaClassName $selection] {

		"Package" {

#code to extract the attributes associated with associations, we don't export them as attributes of the class
			MapRole $selection Diagram ForAssociationAttributes

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
			MapRole $selection Signature ForWriting

set package_id [u2::GetValue $selection Guid]
u2::MetaVisit $selection usecaseDefinition


			MapRole $selection Implementation ForInternal
			MapRole $selection Attribute ForWriting
			MapRole $selection Performance ForPerfomance

			MapRole $selection Signature ForAssociation_Class
			MapRole $selection Diagram ForExtension
 
                        MapRole $selection Signature ForPerfomance    
                        MapRole $selection Association ForPerfomance       



 			set Stereotype_Name ""
			set Stereotype_count 0
			MapRole $selection StereotypeInstance ForInstance
			if {$Stereotype_Name != ""} {
			set guid [u2::GetValue $selection Guid]
			set base "Package"
			Writing_Stereotype $selection $Stereotype_Name $guid $base



			}


			MapRole $selection SubPackage ForWriting
			MapRole $selection ClientDependency ForDependency

# Code to export Realize relationships to XMI
			set extended_text ""
                       	MapRole $selection Signature ForRealize
                                         
			if {$isRealize == 1} {
				set id "St."
				append id "$Stereo_id"
				set name "realize"
				set base "Abstraction"
				Writing_Stereotype $id $name $extended_text $base

				set Stereo_id [expr $Stereo_id + 1]

			}
                       
                         	MapRole $selection Attribute ForRealize

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			}

		"Attribute" {

			global isActor
			set isActor ""
			MapRole $selection AppliedStereotypeInstance Fortype

		set class ""
		MapRole $selection Owner ForOwner



 
		if {$isActor == "Actor"} {
			#set text "<UML:"
			#append text "Namespace.ownedElement> "
			#puts $file $text
		
			MapRole $selection InlineType ForWriting
			
			#set text "</UML:"
			#append text "Namespace.ownedElement> "
			#puts $file $text

		}
                          
			 if {$isActor!="Actor"} {               
               		 MapRole $selection Type ForName
                         MapRole $selection DefaultValue ForDefault
                         set text "<UML:"
                	 append text "Attribute.initialValue> "
			 puts $file $text
                             set text "<UML:Expression body=\"$IntValue\"/>"
                             puts $file $text   
        
                          set text "</UML:"
			  append text "Attribute.initialValue> "
           		  puts $file $text
                          set IntValue ""
        	}
			 if {$isActor!="Actor" && $Export_Rose == 0} { 
				MapRole $selection Multiplicity ForMultiplicity

			if {$open != ""} {
					set lower $open
					set upper $open
					if {$operator == ">=" || $operator == ">" } {
						set upper "*"
					}
				}
			
				set text "<UML:"
				append text "Attribute.multiplicity>"
				puts $file $text
		
				set text "<UML:"
				append text "Multiplicity>"
				puts $file $text

				if {$lower!= "" && $upper!= ""} {

				set text "<UML:"
				append text "Multiplicity.range>"
				puts $file $text

				set text "<UML:MultiplicityRange "
				append text "xmi.id=\"M.$Multiplicity_id\" "
				append text "lower=\"$lower \" "
				append text "upper=\"$upper \" >"
				puts $file $text
		
				set text "</UML:"
				append text "MultiplicityRange>"
				puts $file $text

				set text "</UML:"
				append text "Multiplicity.range>"
				puts $file $text

				}

				set text "</UML:"
				append text "Multiplicity>"
				puts $file $text

				set text "</UML:"
				append text "Attribute.multiplicity>"
				puts $file $text
				set Multiplicity_id [expr $Multiplicity_id +1]


			}

		}

		"Class" {
			
			if {$Export_Rose == 1} {
 				set text "<UML:"
				append text "ModelElement.templateParameter>"
				puts $file $text
	
				MapRole $selection FormalTemplateParameter WritinginXMITemplate
				set text "</UML:"
				append text "ModelElement.templateParameter>"
				puts $file $text
			}

			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			MapRole $selection Signature ForWriting_Class
			MapRole $selection Attribute ForWriting_Att

			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			MapRole $selection Signature ForWriting
if {$Export_Rose==1} {	
			MapRole $selection Attribute ForWriting_Class
}
			MapRole $selection Internals ForInternal

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

                        	
                               MapRole $selection Generalization Gen
	               

      			 }
		"Interface" {


			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text
			MapRole $selection Signature ForWriting_Class
                        if {$Export_Rose==0} {
                            MapRole $selection Attribute ForWriting
                        } 
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text
				   	  
      			 }
		"Timer" {
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text
			MapRole $selection Parameter ForWriting_Para
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text
	
				   	  
      			 }
		"Signal" {
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text
			MapRole $selection Parameter ForWriting_Para
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text
	
	
				   	  
      			 }
		"Operation" {

                       	MapRole $selection InlineMethod ForWriting_Implement
			MapRole $selection Owner ForOwner

			if {$class == "Package" || $class == "Collaboration"} {
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text
                        MapRole $selection Parameter ForWriting_Para
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

                 	} else {
			set text "<UML:"
			append text "BehavioralFeature.parameter> "
			puts $file $text
                        set OpName [Get $selection Name]

                        MapRole $selection Parameter WritingOperationPara
                
 			set text "</UML:"
			append text "BehavioralFeature.parameter> "
			puts $file $text
			}
                
                       
                               MapRole $selection Generalization Gen
	            
				  
      			 }
		"StateMachine" {

			MapRole $selection InlineMethod ForWriting_Implement
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			MapRole $selection Parameter ForWriting_Para
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text
	
	
				   	  
      			 }
		"DataType" {
			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
			MapRole $selection OwnedMember ForWriting
			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

	                set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text	
                             MapRole $selection Literal ForWriting_Para
                             MapRole $selection Operation ForWriting_Class 
                        set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text


	
      			 }
		"Artifact" {

			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			MapRole $selection Attribute ForWriting

			MapRole $selection Signature ForWriting_Class

			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			MapRole $selection Signature ForWriting

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text
	
	
				   	  
      			 }
		"Collaboration" {
                       	if {$Export_Rose==1} {			
                               MapRole $selection Generalization Gen
	        	
			set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			MapRole $selection Attribute ForWriting
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text
			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			MapRole $selection Signature ForWriting
			MapRole $selection Attribute ForWriting_Class

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text 
			}	
				   	  
      			 }
		"Choice" {
	
                        set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text

			MapRole $selection Signature ForWriting_Class
			MapRole $selection Attribute ForWriting_Att

			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			MapRole $selection Signature ForWriting
if {$Export_Rose==1} {	
			MapRole $selection Attribute ForWriting_Class
}
		
			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text


				   	  
      			 }
		"Stereotype" { 

                       	if {$Export_Rose==1} {

		       set text "<UML:"
			append text "Classifier.feature> "
			puts $file $text
			  MapRole $selection Attribute ForWriting
                          MapRole $selection Signature ForWriting_Class
                        
			set text "</UML:"
			append text "Classifier.feature> "
			puts $file $text

			set text "<UML:"
			append text "Namespace.ownedElement> "
			puts $file $text

			MapRole $selection Signature ForWriting

			set text "</UML:"
			append text "Namespace.ownedElement> "
			puts $file $text 	

                               MapRole $selection Generalization Gen
	                }
				   	  
      			 }
		"SynType" {
			
			}
		"SignalList" {
		
			}


	}
	
} 

# Procedure to call Procedure for accessing Internals
proc ForInternal {selection} {


set fail [catch {MapRole $selection OwnedMember ForWriting} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

return 1
	
}

 

# Procedure to call Procedure for writing Parameters

proc ForWriting_Para {selection} {
 	WritinginXMI_Para $selection

return 1
	
}

# Procedure to call Procedure for writing Attributes of Class if they are not roles

proc get_isRole {selection} {
global isRole
set isRole 1

}


proc ForWriting_Att {selection} {

global list_attributes
global isRole
set isRole 0
global name
set owner ""

# Check whether the attribute is associated with an association
foreach item $list_attributes {
	if {$item == [u2::GetValue $selection Guid]} {
		set isRole 1
	}

}
	
	set fail [catch {MapRole $selection ParticipatesIn get_isRole} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}




	if { $isRole == 0} {
		WritinginXMI $selection
	}
return 1
	

}




proc ForWriting_Class {selection} {
	WritinginXMI_Class $selection

return 1
	
}

proc ForWriting {selection} {

#Defining all variables

global pendingLine
global indent
global optstreaming 
global id
global owner 
global font_size
global font_name
global color
global Assoc_id
global default_size
global default_Font
global owner_prev
global commenttext_prev
global Stereo_id
global comment_id
global commentsymbol_id
global Model_id
global xmlNS

set xmlNS ""
set optStreaming 0
set id 1
set idLast 0
set pendingLine 0
set indent 0
set optStreaming 0
set owner 0
set font_size 12
set font_name Arial
set color 16777215
set Assoc_id 1
set owner_prev 0
set commenttext_prev ""
set default_size 10
set default_Font Arial
set default_color 16773875

# Comment for TST3019725 Dated : 09 Nov 2005 
# By Rashid
#set Stereo_id 1

set comment_id 1
set commentsymbol_id 1
set Model_id 1
 

if {[u2::GetMetaClassName $selection] != "Association"} {
	WritinginXMI $selection
}

return 1
	
}

#---------------------- DATA TYPE  ---------

proc DataTypeDefinition {definition} {

      Traverse_Data $definition
}


proc Traverse_Data {selection} {



	switch -- [u2::GetMetaClassName $selection] {
       
		"Package" {


                        u2::MetaVisit $selection PrintDefinition


      			 }

		}
}


#----------------------------------



proc StartWriting {Resource} {


set fail [catch {MapRole $Resource Root ForWriting} error]
if {$fail} {
 	  Report $Resource "Catch Error" $error
}


return 1
}

global u2FileName 
proc ForEachResource {Resource} {
global file
global Model_id

global DataType_list


global isu2File 
global u2FileName 
global ModelNumber


if {$isu2File==1} {
	set ModelName $u2FileName 
	  
			
} else {

set fail [catch {set curProj [std::GetActiveProject]} error]
if {$fail} {
 	  Report $Resource "Catch Error" $error
}


set fail [catch {set ProjPath [Get $curProj pathname]} error]
if {$fail} {
 	  Report $Resource "Catch Error" $error
}


set fail [catch {set fileName [file rootname $ProjPath]} error]
if {$fail} {
 	  Report $Resource "Catch Error" $error
}


set fail [catch {set ModelName [file tail $fileName]} error]
if {$fail} {
 	  Report $Resource "Catch Error" $error
}
}

set this "Model"
set umltype "UML:"
append umltype $this
set id ""

StartUMLElement_Model $this $umltype $id $ModelName $Resource

set text "<UML:Namespace.ownedElement>"	
puts $file $text
	
 	set fail [catch {MapRole $Resource RootResource StartWriting} error]
	if {$fail} {
 
		Report $Resource "Catch Error"  $error 		
	}

	
	set fail [catch {u2::MetaVisit $Resource StMachineDefinition} error]
	 
	if {$fail} {
 
 	         Report $Resource "Catch Error"  $error  	
	}

	
	set fail [catch {u2::MetaVisit $Resource StereoDefinition} error]
	 
	if {$fail} {
 
		Report $Resource "Catch Error"  $error 
	}


# --------------- FOR DATA TYPE ------------------------



 
u2::MetaVisit $ModelNumber DataTypeDefinition 		

	
#--------------------------------------------------------


set text "</UML:Namespace.ownedElement>"	
puts $file $text	
set comment ""
EndUMLElement $this $umltype $comment

set Model_id [expr $Model_id + 1]
  return 1

}

