/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#if defined(HPUXANSICC) || (defined(__STRICT_ANSI__) && ! defined(__linux)) || (defined(__BORLANDC__) && (__BORLANDC__ <= 0x530))
#define LIMIT_FIELD_WIDTH
#endif

CUCF_ERROR(ec_SUCCESS, "Ok")

/* Memory errors */
CUCF_ERROR(ec_MEM_NotEnoughMemory, "Not enough memory")

/* Buffer errors */
CUCF_ERROR(ec_BUF_DifferentBufferTypes, "Different buffer types in the BufCopyBuf")
CUCF_ERROR(ec_BUF_WrongBufferType, "Wrong buffer type")
CUCF_ERROR(ec_BUF_CloseNotInitialized, "Closing not initialized buffer")
CUCF_ERROR(ec_BUF_WorkWithNotInitialized, "Work with not initialized buffer")
CUCF_ERROR(ec_BUF_NullPtrToUserMemory, "NULL pointer to user memory")
CUCF_ERROR(ec_BUF_NotEnoughUserMemory, "Not enough user memory")
CUCF_ERROR(ec_BUF_OpenOpened, "Opening of already opened buffer")
CUCF_ERROR(ec_BUF_IllegalClose, "Closing buffer which is still opens in read or write mode")
CUCF_ERROR(ec_BUF_CloseWrongMode, "Closing buffer with wrong mode")
CUCF_ERROR(ec_BUF_OperationWrongMode, "Operation at wrong mode")
CUCF_ERROR(ec_BUF_NoMoreDataForRead, "No more data for read")
CUCF_ERROR(ec_BUF_TooBigNumberOfBits, "Too big number of bits")
CUCF_ERROR(ec_BUF_InvalidEncodingRules, "The combination of bit masks does not form a valid encoding rule")

/* Internal errors */
#ifdef LIMIT_FIELD_WIDTH
CUCF_ERROR(ec_INT_InternalError, "Internal error: \"%.200s\", line %d")
#else
CUCF_ERROR(ec_INT_InternalError, "Internal error: \"%s\", line %d")
#endif
CUCF_ERROR(ec_INT_UnsupportedType, "Unsupported type")

/* Value errors */
CUCF_ERROR(ec_VAL_IllegalRealBase, "Illegal REAL value base")
CUCF_ERROR(ec_VAL_WrongConstrainedValue, "Wrong constrained INTEGER value")
#ifdef LIMIT_FIELD_WIDTH
CUCF_ERROR(ec_VAL_WrongConstrainedLength, "Wrong constrained length of %.200s value")
CUCF_ERROR(ec_VAL_WrongConstrainedAlphabet, "Wrong constrained alphabet of %.200s value")
#else
CUCF_ERROR(ec_VAL_WrongConstrainedLength, "Wrong constrained length of %s value")
CUCF_ERROR(ec_VAL_WrongConstrainedAlphabet, "Wrong constrained alphabet of %s value")
#endif

/* Decode errors */
#ifdef LIMIT_FIELD_WIDTH
CUCF_ERROR(ec_DEC_WrongIdentifierOctet, "Wrong identifier octet for %.200s type")
CUCF_ERROR(ec_DEC_WrongLength, "Wrong length for %.200s type")
#else
CUCF_ERROR(ec_DEC_WrongIdentifierOctet, "Wrong identifier octet for %s type")
CUCF_ERROR(ec_DEC_WrongLength, "Wrong length for %s type")
#endif
CUCF_ERROR(ec_DEC_TooBigTagNumber, "Too big tag number")
CUCF_ERROR(ec_DEC_WrongConstructedLengthPrefix, "Wrong constructed length prefix")
CUCF_ERROR(ec_DEC_WrongUnusedBits, "Wrong BIT STRING unused bits")
CUCF_ERROR(ec_DEC_TooBigSubIdent, "Too big OBJECT IDENTIFIER subidentifier")
CUCF_ERROR(ec_DEC_WrongRealPrefix, "Wrong REAL prefix")
CUCF_ERROR(ec_DEC_UnsupportedRealBase, "Unsupported REAL base")
CUCF_ERROR(ec_DEC_UnsupportedRealDecimalEncoding, "Unsupported REAL decimal encoding")
CUCF_ERROR(ec_DEC_RequiredComponentIsAbsent, "Required component is absent")
CUCF_ERROR(ec_DEC_ExtRequiredComponentIsAbsent, "Required component at the extension group is absent")
CUCF_ERROR(ec_DEC_AbsentComponentIsPresent, "Absent component is present")
CUCF_ERROR(ec_DEC_AbsentAlternativeIsPresent, "Absent alternative is present")
CUCF_ERROR(ec_DEC_UnknownComponent, "Unknown component")
CUCF_ERROR(ec_DEC_UnknownAlternative, "Unknown alternative")
CUCF_ERROR(ec_DEC_NoOpenId, "No open identifier for open type")
CUCF_ERROR(ec_DEC_UnknownObject, "Unknown object of open type")

/* Ascii errors */
#if defined(CODER_VMS_SDT) && !defined(CODER_REMOVE_ASCII)
CUCF_ERROR(ec_ERROR_DECODING_INTEGER, "Error when decoding integer from buffer")
CUCF_ERROR(ec_ERROR_DECODING_REAL, "Error when decoding real from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BOOLEAN, "Error when decoding boolean from buffer")
CUCF_ERROR(ec_ERROR_DECODING_TIME, "Error when decoding time or duration from buffer")
CUCF_ERROR(ec_ERROR_DECODING_CHARSTRING, "Error when decoding character string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BIT, "Error when decoding bit from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BITSTRING, "Error when decoding bit string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_OCTET, "Error when decoding octet from buffer")
CUCF_ERROR(ec_ERROR_DECODING_OCTETSTRING, "Error when decoding octet string from buffer")
CUCF_ERROR(ec_ERROR_DECODING_SIGNALID, "Error when decoding signal id from buffer")
CUCF_ERROR(ec_ERROR_DECODING_STRUCT, "Error when decoding struct from buffer")
CUCF_ERROR(ec_ERROR_DECODING_CHOICE, "Error when decoding choice or union from buffer")
CUCF_ERROR(ec_ERROR_DECODING_POWERSET, "Error when decoding powerset from buffer")
CUCF_ERROR(ec_ERROR_DECODING_BAG, "Error when decoding bag from buffer")
CUCF_ERROR(ec_ERROR_DECODING_STRING, "Error when decoding string, powerset or object identifier from buffer")
CUCF_ERROR(ec_ERROR_DECODING_ARRAY, "Error when decoding array from buffer")
CUCF_ERROR(ec_ERROR_DECODING_REF, "Error when decoding ref,oref or own from buffer")
CUCF_ERROR(ec_ERROR_DECODING_USERDEF, "Error when decoding PId, userdef, C union, char * or void * from buffer")
CUCF_ERROR(ec_ERROR_UNKNOWN_TYPE_NODE, "Unknown type node as input")
CUCF_ERROR(ec_ERROR_DECODING_PARSTART, "Error when decoding start of signal parameter or variable")
CUCF_ERROR(ec_ERROR_DECODING_PAREND, "Error when decoding end of signal parameter or variable")
#endif /* CODER_VMS_SDT && !CODER_REMOVE_ASCII */

/* User errors */
#ifdef CODER_EC_USER
#include CODER_EC_USER
#endif

