/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_macro_h
#define __vms_macro_h

#include "cucf_cfg.h"

#define TYPE_REF(typename) (tASN1TypeInfo*)&typename

#define BOOLEAN_TYPE_DECL(specifier, typename) \
  specifier tASN1Boolean typename

#define NULL_TYPE_DECL(specifier, typename) \
  specifier tASN1Null typename

#define OBJECT_IDENTIFIER_TYPE_DECL(specifier, typename) \
  specifier tASN1ObjectIdentifier typename

#define REAL_TYPE_DECL(specifier, typename) \
  specifier tASN1Real typename

#define INTEGER_TYPE_DECL(specifier, typename) \
  specifier tASN1Integer typename

#define CONSTRAINED_INTEGER_TYPE_DECL(specifier, typename) \
  specifier tASN1Integer typename

#define BIT_STRING_TYPE_DECL(specifier, typename) \
  specifier tASN1BitString typename

#define CONSTRAINED_BIT_STRING_TYPE_DECL(specifier, typename) \
  specifier tASN1BitString typename

#define OCTET_STRING_TYPE_DECL(specifier, typename) \
  specifier tASN1OctetString typename

#define CONSTRAINED_OCTET_STRING_TYPE_DECL(specifier, typename) \
  specifier tASN1OctetString typename

#define NumericString_TYPE_DECL(specifier, typename) \
  specifier tASN1NumericString typename

#define CONSTRAINED_NumericString_TYPE_DECL(specifier, typename) \
  specifier tASN1NumericString typename

#define PrintableString_TYPE_DECL(specifier, typename) \
  specifier tASN1PrintableString typename

#define CONSTRAINED_PrintableString_TYPE_DECL(specifier, typename) \
  specifier tASN1PrintableString typename

#define IA5String_TYPE_DECL(specifier, typename) \
  specifier tASN1IA5String typename

#define CONSTRAINED_IA5String_TYPE_DECL(specifier, typename) \
  specifier tASN1IA5String typename

#define VisibleString_TYPE_DECL(specifier, typename) \
  specifier tASN1VisibleString typename

#define CONSTRAINED_VisibleString_TYPE_DECL(specifier, typename) \
  specifier tASN1VisibleString typename

#define UTCTime_TYPE_DECL(specifier, typename) \
  specifier tASN1UTCTime typename

#define GeneralizedTime_TYPE_DECL(specifier, typename) \
  specifier tASN1GeneralizedTime typename

#define ENUMERATED_TYPE_DECL(specifier, typename) \
  specifier tASN1Enumerated typename

#define SEQUENCE_TYPE_DECL(specifier, typename) \
  specifier tASN1Sequence typename

#define SET_TYPE_DECL(specifier, typename) \
  specifier tASN1Sequence typename

#define SEQUENCE_OF_TYPE_DECL(specifier, typename) \
  specifier tASN1SequenceOf typename

#define CONSTRAINED_SEQUENCE_OF_TYPE_DECL(specifier, typename) \
  specifier tASN1SequenceOf typename

#define SET_OF_TYPE_DECL(specifier, typename) \
  specifier tASN1SetOf typename

#define CONSTRAINED_SET_OF_TYPE_DECL(specifier, typename) \
  specifier tASN1SetOf typename

#define CHOICE_TYPE_DECL(specifier, typename) \
  specifier tASN1Choice typename

#define DEFINED_TYPE_DECL(specifier, typename) \
  specifier tASN1Defined typename

#ifdef CODER_REMOVE_BER
#define TAGGED_TYPE_DECL(specifier, typename)
#else
#define TAGGED_TYPE_DECL(specifier, typename) \
  specifier tASN1Tagged typename
#endif

#define OPEN_ID_DECL(specifier, typename) \
  specifier tASN1OpenId typename

#define OPEN_TYPE_DECL(specifier, typename) \
  specifier tASN1Open typename


#define BOOLEAN_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1Boolean typename = \
    { \
      type_ASN1_BOOLEAN \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
    }

#define NULL_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1Null typename = \
    { \
      type_ASN1_NULL \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
    }

#define OBJECT_IDENTIFIER_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1ObjectIdentifier typename = \
    { \
      type_ASN1_OBJECT_IDENTIFIER \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
    }

#define REAL_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1Real typename = \
    { \
      type_ASN1_REAL \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
    }

#define INTEGER_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1Integer typename = \
    { \
      type_ASN1_INTEGER \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(0, 0, 0, em_Absent) \
    }

#define CONSTRAINED_INTEGER_TYPE_DEF(specifier, typename, \
                                     islbound, lbound, isubound, ubound, \
                                     isextmarker, \
                                     vrtype) \
  specifier tASN1Integer typename = \
    { \
      type_ASN1_INTEGER \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(((islbound << 4) | isubound), lbound, ubound, \
                                     ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent)) \
    }

#define BIT_STRING_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1BitString typename = \
    { \
      type_ASN1_BIT_STRING \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(0, 0, 0, em_Absent) \
    }

#define CONSTRAINED_BIT_STRING_TYPE_DEF(specifier, typename, \
                                        islbound, lbound, isubound, ubound, \
                                        isextmarker, \
                                        vrtype) \
  specifier tASN1BitString typename = \
    { \
      type_ASN1_BIT_STRING \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(isubound, \
                                     ((islbound == BOUND_PRESENT) ? lbound : 0), \
                                     ((isubound == BOUND_PRESENT) ? ubound : 0), \
                                     ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent)) \
    }

#define OCTET_STRING_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1OctetString typename = \
    { \
      type_ASN1_OCTET_STRING \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(0, 0, 0, em_Absent) \
    }

#define CONSTRAINED_OCTET_STRING_TYPE_DEF(specifier, typename, \
                                          islbound, lbound, isubound, ubound, \
                                          isextmarker, \
                                          vrtype) \
  specifier tASN1OctetString typename = \
    { \
      type_ASN1_OCTET_STRING \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CONSTRAINT(isubound,\
                                     ((islbound == BOUND_PRESENT) ? lbound : 0), \
                                     ((isubound == BOUND_PRESENT) ? ubound : 0), \
                                     ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent)) \
    }

#define NumericString_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1NumericString typename = \
    { \
      type_ASN1_NumericString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#define CONSTRAINED_NumericString_TYPE_DEF(specifier, typename, \
                                           islbound, lbound, isubound, ubound, \
                                           isextmarker, \
                                           alphabet, alphabetlen, \
                                           vrtype) \
  specifier tASN1NumericString typename = \
    { \
      type_ASN1_NumericString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT ( \
      isubound,\
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent), \
      alphabet, \
      alphabetlen ) \
    }

#define PrintableString_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1PrintableString typename = \
    { \
      type_ASN1_PrintableString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#define CONSTRAINED_PrintableString_TYPE_DEF(specifier, typename, \
                                             islbound, lbound, isubound, ubound, \
                                             isextmarker, \
                                             alphabet, alphabetlen, \
                                             vrtype) \
  specifier tASN1PrintableString typename = \
    { \
      type_ASN1_PrintableString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT ( \
      isubound,\
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent), \
      alphabet, \
      alphabetlen )\
    }

#define IA5String_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1IA5String typename = \
    { \
      type_ASN1_IA5String \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#define CONSTRAINED_IA5String_TYPE_DEF(specifier, typename, \
                                       islbound, lbound, isubound, ubound, \
                                       isextmarker, \
                                       alphabet, alphabetlen, \
                                       vrtype) \
  specifier tASN1IA5String typename = \
    { \
      type_ASN1_IA5String \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT ( \
      isubound,\
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent), \
      alphabet, \
      alphabetlen )\
    }

#define VisibleString_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1VisibleString typename = \
    { \
      type_ASN1_VisibleString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#define CONSTRAINED_VisibleString_TYPE_DEF(specifier, typename, \
                                           islbound, lbound, isubound, ubound, \
                                           isextmarker, \
                                           alphabet, alphabetlen, \
                                           vrtype) \
  specifier tASN1VisibleString typename = \
    { \
      type_ASN1_VisibleString \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT ( \
      isubound,\
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent), \
      alphabet, \
      alphabetlen )\
    }

#define UTCTime_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1UTCTime typename = \
    { \
      type_ASN1_UTCTime \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#define GeneralizedTime_TYPE_DEF(specifier, typename, vrtype) \
  specifier tASN1GeneralizedTime typename = \
    { \
      type_ASN1_GeneralizedTime \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      VMS_CONSTRAINTC VMS_CHARSTRING_CONSTRAINT(0, 0, 0, em_Absent, NULL, 0) \
    }

#if !defined(CODER_NOUSE_ENUMERTAED_ITEMS) || defined(CODER_VMS_PRINT)
#define ENUMERATED_TYPE_DEF(specifier, typename, \
                            isextmarker, extmarker, \
                            items, \
                            vrtype) \
  static tASN1Item typename##Items[] = items; \
  specifier tASN1Enumerated typename = \
    { \
      type_ASN1_ENUMERATED \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      typename##Items, \
      (sizeof(typename##Items) / sizeof(tASN1Item)), \
      (isextmarker == EXTMARKER_PRESENT) ? extmarker : -1 \
    }
#else
#define ENUMERATED_TYPE_DEF(specifier, typename, \
                            isextmarker, extmarker, \
                            items, \
                            vrtype) \
  specifier tASN1Enumerated typename = \
    { \
      type_ASN1_ENUMERATED \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (isextmarker == EXTMARKER_PRESENT) ? extmarker : -1 \
    }
#endif

#define ITEMS(items) { items }

#define ITEM(name, number) { VMS_TYPENAME((char*)#name) VMS_TYPENAMEC number }

/*#define SEQUENCE_TYPE_DEF(specifier, typename, isextmarker, root, noptdef, nextadd, \
                          root1, extadd, root2, \
                          vrtype) \
  static tASN1Component typename##RootComps1[] = root1; \
  static tASN1Component typename##ExtAddComps[] = extadd; \
  static tASN1Component typename##RootComps2[] = root2; \
  specifier tASN1Sequence typename = \
    { \
      type_ASN1_SEQUENCE \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      typename##RootComps1, \
      typename##ExtAddComps, \
      typename##RootComps2, \
      (root << 4) | isextmarker, \
      (sizeof(typename##RootComps1) / sizeof(tASN1Component)), \
      (sizeof(typename##ExtAddComps) / sizeof(tASN1Component)), \
      (sizeof(typename##RootComps2) / sizeof(tASN1Component)) \
      VMS_PERC VMS_PER(noptdef) \
      VMS_PERC VMS_PER(nextadd) \
      }*/

#define SEQUENCE_TYPE_DEF(specifier, typename, isextmarker, root, noptdef, nextadd, \
                          m_root1, root1, m_extadd, extadd, m_root2, root2, \
                          vrtype) \
  m_root1(typename, ##root1, 1) \
  m_extadd(typename, ##extadd, 2) \
  m_root2(typename, ##root2, 3) \
  specifier tASN1Sequence typename = \
    { \
      type_ASN1_SEQUENCE \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      m_root1##_REF(typename, 1), \
      m_extadd##_REF(typename, 2), \
      m_root2##_REF(typename, 3), \
      (root << 4) | isextmarker, \
      (sizeof(m_root1##_REF(typename, 1)) / sizeof(tASN1Component)), \
      (sizeof(m_extadd##_REF(typename, 2)) / sizeof(tASN1Component)), \
      (sizeof(m_root2##_REF(typename, 3)) / sizeof(tASN1Component)) \
      VMS_PERC VMS_PER(noptdef) \
      VMS_PERC VMS_PER(nextadd) \
      }

#define SET_TYPE_DEF(specifier, typename, isextmarker, root, noptdef, nextadd, \
                     m_root1, root1, m_extadd, extadd, m_root2, root2, \
                     vrtype) \
  m_root1(typename, ##root1, 1) \
  m_extadd(typename, ##extadd, 2) \
  m_root2(typename, ##root2, 3) \
  specifier tASN1Sequence typename = \
    { \
      type_ASN1_SET \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      m_root1##_REF(typename, 1), \
      m_extadd##_REF(typename, 2), \
      m_root2##_REF(typename, 3), \
      (root << 4) | isextmarker, \
      (sizeof(m_root1##_REF(typename, 1)) / sizeof(tASN1Component)), \
      (sizeof(m_extadd##_REF(typename, 2)) / sizeof(tASN1Component)), \
      (sizeof(m_root2##_REF(typename, 3)) / sizeof(tASN1Component)) \
      VMS_PERC VMS_PER(noptdef) \
      VMS_PERC VMS_PER(nextadd) \
      }

#define PRESENT_LIST(typename, components, num) \
static tASN1Component typename##Comps##num [] = components;

#define ABSENT_LIST(typename, components, num)

#define PRESENT_LIST_REF(typename, num) \
typename##Comps##num

#define ABSENT_LIST_REF(typename, num) \
NULL

#define EMPTY_LIST 

#define ROOT_COMPONENTS(components) { components }
#define EXTADD_COMPONENTS(components) { components }

#define REQUIRED_COMPONENT(typename, componentname, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#componentname) \
    , \
    ct_Required, \
    index \
  }

#define OPTIONAL_COMPONENT(typename, componentname, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#componentname) \
    , \
    ct_Optional, \
    index \
  }

#define DEFAULT_COMPONENT(typename, componentname, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#componentname) \
    , \
    ct_Default, \
    index \
  }

#define PRESENT_COMPONENT(typename, componentname, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#componentname) \
    , \
    ct_Present, \
    index \
  }

#define ABSENT_COMPONENT(typename, componentname, typenameref) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#componentname) \
    , \
    ct_Absent, \
    0 \
  }

#define ADDITION_GROUP(numofcomps, components) \
  { \
    NULL \
    VMS_TYPENAMEC VMS_TYPENAME((char*)"") \
    , \
    ct_Group, \
    numofcomps \
  }, \
  components


#define SEQUENCE_OF_TYPE_DEF(specifier, typename, typenameref, \
                             vrtype) \
  specifier tASN1SequenceOf typename = \
    { \
      type_ASN1_SEQUENCE_OF \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
      VMS_CONSTRAINTC VMS_CONSTRAINT(0, 0, 0, em_Absent) \
    }

#define CONSTRAINED_SEQUENCE_OF_TYPE_DEF(specifier, typename, typenameref, \
                                         islbound, lbound, isubound, ubound, \
                                         isextmarker, \
                                         vrtype) \
  specifier tASN1SequenceOf typename = \
    { \
      type_ASN1_SEQUENCE_OF \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
      VMS_CONSTRAINTC VMS_CONSTRAINT( \
      isubound,\
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent)) \
    }

#define SET_OF_TYPE_DEF(specifier, typename, typenameref, \
                        vrtype) \
  specifier tASN1SetOf typename = \
    { \
      type_ASN1_SET_OF \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
      VMS_CONSTRAINTC VMS_CONSTRAINT(0, 0, 0, em_Absent) \
    }

#define CONSTRAINED_SET_OF_TYPE_DEF(specifier, typename, typenameref, \
                                    islbound, lbound, isubound, ubound, \
                                    isextmarker, \
                                    vrtype) \
  specifier tASN1SetOf typename = \
    { \
      type_ASN1_SET_OF \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
      VMS_CONSTRAINTC VMS_CONSTRAINT( \
      isubound, \
      ((islbound == BOUND_PRESENT) ? lbound : 0), \
      ((isubound == BOUND_PRESENT) ? ubound : 0), \
      ((isextmarker == EXTMARKER_PRESENT) ? em_Present : em_Absent)) \
    }

#define CHOICE_TYPE_DEF(specifier, typename, \
                        isextmarker, extmarker, \
                        alternatives, \
                        vrtype) \
  static tASN1Alternative typename##Alternatives[] = alternatives; \
  specifier tASN1Choice typename = \
    { \
      type_ASN1_CHOICE \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (isextmarker == EXTMARKER_PRESENT) ? extmarker : -1, \
      typename##Alternatives, \
      (sizeof(typename##Alternatives) / sizeof(tASN1Alternative)) \
    }

#define ALTERNATIVES(alternatives) { alternatives }

#define REQUIRED_ALTERNATIVE(typename, alternativename, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#alternativename) \
    , \
    ct_Required, \
    index \
  }

#define ABSENT_ALTERNATIVE(typename, alternativename, typenameref) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#alternativename) \
    , \
    ct_Absent, \
    0 \
  }

#define DEFINED_TYPE_DEF(specifier, typename, typenameref, vrtype) \
  specifier tASN1Defined typename = \
    { \
      type_ASN1_DEFINED \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
    }

#ifdef CODER_REMOVE_BER
#define TAGGED_OR_DIRECT_REF(tagged_typeref, direct_typeref) \
  direct_typeref
#define TAGGED_TYPE_DEF(specifier, typename, tags, typenameref, vrtype)
#else
#define TAGGED_OR_DIRECT_REF(tagged_typeref, direct_typeref) \
  tagged_typeref
#define TAGGED_TYPE_DEF(specifier, typename, tags, typenameref, vrtype) \
  VMS_BER(static tASN1Tag typename##Tags[] = ) tags VMS_BER(;) \
  specifier tASN1Tagged typename = \
    { \
      type_ASN1_TAGGED \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
      VMS_BERC VMS_BER( \
      typename##Tags VMS_BERC \
      (sizeof(typename##Tags) / sizeof(tASN1Tag)) \
      ) \
    }
#endif

#define OPEN_ID_DEF(specifier, typename, typenameref, vrtype) \
  specifier tASN1OpenId typename = \
    { \
      type_ASN1_OPEN_ID \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref \
    }

#define EMPTY_OPEN_TYPE_DEF(specifier, typename, typenameref, vrtype) \
  specifier tASN1Open typename = \
    { \
      type_ASN1_OPEN \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref, \
      NULL, \
      0 \
    }

#define OPEN_TYPE_DEF(specifier, typename, typenameref, \
                      initobjects, objects, \
                      vrtype) \
  initobjects \
  static tASN1Object typename##Objects[] = objects; \
  specifier tASN1Open typename = \
    { \
      type_ASN1_OPEN \
      VMS_VRTYPEC VMS_VRTYPE((const tVMSPointer)&vrtype) \
      VMS_TYPENAMEC VMS_TYPENAME((char*)#typename) \
      , \
      (tASN1TypeInfo*)&typenameref, \
      typename##Objects, \
      (sizeof(typename##Objects) / sizeof(tASN1Object)) \
    }

#define INIT_OBJECTS(initobjects) initobjects

#define INIT_OBJECT(typename, objectname, ident, initobjectbody) \
  static void* typename##objectname##ident##InitFunc(tCoder* Coder) \
    { \
      return initobjectbody; \
    }

#define BOOLEAN_VALUE(Boolean) \
  CUCFInitObjectBOOLEAN(Coder, Boolean)

#define NULL_VALUE

#define OBJECT_IDENTIFIER_VALUE(NumberOfComponents, Components) \
  CUCFInitObjectOBJECT_IDENTIFIER(Coder, NumberOfComponents, Components)

#define SUB_IDENT(subident) \
  subident

#define REAL_ZERO_VALUE \
  CUCFInitObjectREAL(Coder, rk_Zero)

#define REAL_MINUS_INFINITY_VALUE \
  CUCFInitObjectREAL(Coder, rk_MINUS_INFINITY)

#define REAL_PLUS_INFINITY_VALUE \
  CUCFInitObjectREAL(Coder, rk_PLUS_INFINITY)

#define REAL_VALUE(Mantissa, Base, Exponent) \
  CUCFInitObjectREAL(Coder, rk_Value, Mantissa, Base, Exponent)

#define INTEGER_VALUE(Integer) \
  CUCFInitObjectINTEGER(Coder, Integer)

#define BIT_STRING_VALUE(BitString, Length) \
  CUCFInitObjectBIT_STRING(Coder, NULL, (tVMSString_Value)BitString, Length)

#define OCTET_STRING_VALUE(OctetString, Length) \
  CUCFInitObjectOCTET_STRING(Coder, NULL, (tVMSString_Value)OctetString, Length)

#define STRING_VALUE(String, Length) \
  CUCFInitObjectCHARACTER_STRING(Coder, (tVMSString_Value)String, Length)

#define ENUMERATED_VALUE(Enumerated_Index) \
  CUCFInitObjectENUMERATED(Coder, Enumerated_Index)

#define SEQUENCE_VALUE(NumberOfComponents, Components) \
  CUCFInitObjectStruct(Coder, NumberOfComponents, Components)

#define SET_VALUE(NumberOfComponents, Components) \
  CUCFInitObjectStruct(Coder, NumberOfComponents, Components)

#define COMPONENT_VALUE(component) \
  component

#define NONE_VALUE NULL

#define SEQUENCE_OF_VALUE(NumberOfComponents, Components) \
  CUCFInitObjectStruct(Coder, NumberOfComponents, Components)

#define SET_OF_VALUE(NumberOfComponents, Components) \
  CUCFInitObjectStruct(Coder, NumberOfComponents, Components)

#define CHOICE_VALUE(Index, Alternative) \
  CUCFInitObjectCHOICE(Coder, Index, Alternative)

#define OPEN_VALUE(Index, Object) \
  CUCFInitObjectOPEN(Coder, Index, Object)

#define OBJECTS(objects) { objects }

#define OBJECT(typename, objectname, ident, typenameref, index) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#objectname) \
    , \
    (tCUCFObjectInitFunc)typename##objectname##ident##InitFunc, \
    index \
  }

#define SIMPLE_OBJECT(objectname, typenameref, index, value) \
  { \
    (tASN1TypeInfo*)&typenameref \
    VMS_TYPENAMEC VMS_TYPENAME((char*)#objectname) \
    , \
    (tCUCFObjectInitFunc)(void*)value, \
    index \
  }

#ifdef CODER_VMS_VRTYPE
#define VMS_VRTYPE(arg) arg
#define VMS_VRTYPEC ,
#else
#define VMS_VRTYPE(arg)
#define VMS_VRTYPEC
#endif

#ifdef CODER_VMS_TYPENAME
#define VMS_TYPENAME(arg) arg
#define VMS_TYPENAMEC ,
#else
#define VMS_TYPENAME(arg)
#define VMS_TYPENAMEC
#endif

#ifdef CODER_REMOVE_CONSTRAINTS
#define VMS_CONSTRAINT(mask, lbound, ubound, extmarker)
#define VMS_CHARSTRING_CONSTRAINT(mask, lbound, ubound, extmarker, alphabet, alphabetlen)
#define VMS_CONSTRAINTC
#else
#define VMS_CONSTRAINT(mask, lbound, ubound, extmarker) \
mask, \
{ \
  lbound, \
  ubound, \
  extmarker \
}
#define VMS_CHARSTRING_CONSTRAINT(mask, lbound, ubound, extmarker, alphabet, alphabetlen) \
VMS_CONSTRAINT(mask, lbound, ubound, extmarker), \
  (unsigned char*)alphabet,\
  alphabetlen

#define VMS_CONSTRAINTC ,
#endif


#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_BER)
#define VMS_BER(arg) arg
#define VMS_BERC ,
#define TAGS(tags) { tags }
#define TAG(class, number) { class, number }, 
#else
#define VMS_BER(arg)
#define VMS_BERC
#define TAGS(tags)
#define TAG(class, number)
#endif

#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_PER)
#define VMS_PER(arg) arg
#define VMS_PERC ,
#else
#define VMS_PER(arg)
#define VMS_PERC
#endif

#define GLOBAL_INFO
#define STATIC_INFO static
#define EXTERN_INFO extern

#define VMS_COMMA ,

#define NO_TAG

#define UNIVERSAL                  tc_UT
#define APPLICATION                tc_AP
#define CONTEXT_SPECIFIC           tc_CS
#define PRIVATE                    tc_PR

#define NOTHING

#define EXTMARKER_ABSENT           em_Absent
#define EXTMARKER_PRESENT          em_Present

#define EXTMARKER(number)          number
#define NONE_EXTMARKER             0

#define BOUND_ABSENT               0
#define BOUND_PRESENT              1

#define BOUND(number)              number
#define NONE_BOUND                 0
#define MIN_BOUND                  LONG_MIN
#define MAX_BOUND                  LONG_MAX

#define NONE_ALPHABET              NULL
#define ALPHABET(alphabet)         alphabet
#define NONE_ALPHABET_LEN          0
#define ALPHABET_LEN(alphabetsize) alphabetsize

#define NONE_ROOT                  rs_NonRoot
#define ROOT                       rs_Root

#endif /* __vms_macro_h */

