/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifdef DEBUG_INSTRUMENT_SIDE
#ifdef __cplusplus
extern "C" {
#endif
#endif

#ifndef DEBUG_INSTRUMENT_SIDE

/******************************************************************************/
/* Debugger Agent side */

typedef struct xDAMsgCtx_struct xDAMsgCtx;

extern xDAMsgCtx *xDAMsgInit(struct ComCtx_struct *comctx);

extern void xDAMSync(xDAMsgCtx *ctx,void (*cb)(/*nodelete*/ char *req,/*nodelete*/ char *reqid));

/* one should have a xDAMPoll() function wrapping xDAMsgPoll() to avoid this */
extern void xDAMSyncAckReceived(xDAMsgCtx *ctx);

/*----------------------------------------------------------------------------*/
/* decoding */

/* decode data from the Debugger (command) */
/* moved to sctdacom.h: extern void xDAMsgHandleData(); */

/*----------------------------------------------------------------------------*/
/* encoding */

/* message elements level */

extern void xDAMEncChar(xDAMsgCtx *ctx,char c);
extern void xDAMEncStr(xDAMsgCtx *ctx,char *str);
extern void xDAMEncStrN(xDAMsgCtx *ctx,char *str,int nb_char);
extern void xDAMEncText(xDAMsgCtx *ctx,const char *str);
extern void xDAMEncSep(xDAMsgCtx *ctx);
extern void xDAMEncId(xDAMsgCtx *ctx,struct xIdStruct *p);
extern void xDAMEncNum(xDAMsgCtx *ctx,long n);
extern void xDAMEncExternalPid(xDAMsgCtx *ctx,long nodenr,void *ppid);
extern void xDAMUnEncChar(xDAMsgCtx *ctx,char c);
extern void xDAMEncSkipChar(xDAMsgCtx *ctx,char c);

extern XCONST struct xSignalIdStruct ySigR_DummyStartUp;

/* message level */

extern void xDAMsgSendReady(xDAMsgCtx *ctx);
extern void xDAMsgSendBusy(xDAMsgCtx *ctx);

extern void xDAMsgSendAck(xDAMsgCtx *ctx,const char *reqid);
#define xDAMsgAckBegin(ctx,reqid) xDAMsgReqIDBegin(ctx,reqid,xDAMsgAck_CODE)
#define xDAMsgAckEnd(ctx) xDAMsgFlush(ctx)

/* encode xDAMsgTrace message(s): buffering of str is undefined */
extern void xDAMsgTraceStr(xDAMsgCtx *ctx,const char *str);
/* force sending of buffered xDAMsgTrace strings */
extern void xDAMsgFlush(xDAMsgCtx *ctx);

extern void xDAMsgReqIDBegin(xDAMsgCtx *ctx,const char *reqid,int code);

#define xDAMsgValueBegin(ctx,reqid) xDAMsgReqIDBegin(ctx,reqid,xDAMsgValue_CODE)
#define xDAMsgValueEnd(ctx) xDAMsgFlush(ctx)

#define xDAMsgInstancesBegin(ctx,reqid) xDAMsgReqIDBegin(ctx,reqid,xDAMsgInstances_CODE)
#define xDAMsgInstancesEnd(ctx) xDAMsgFlush(ctx)

extern void xDAMsgStartMscTrace(xDAMsgCtx *ctx);
extern void xDAMsgMscTrace(xDAMsgCtx *ctx,const char *str);
extern void xDAMsgTracking(xDAMsgCtx *ctx, const char *str);

#define xDAMsgUpdateBreakpointsBegin(ctx) (xDAMsgFlush(ctx), xDAMEncChar(ctx,xDAMsgUpdateBreakpoints_CODE))
#define xDAMsgUpdateBreakpointsEnd(ctx) xDAMsgFlush(ctx)

#define xDAMsgCoverageBegin(ctx) (xDAMsgFlush(ctx), xDAMEncChar(ctx,xDAMsgCoverage_CODE))
#define xDAMsgCoverageEnd(ctx) xDAMsgFlush(ctx)

#define xDAMsgStepBegin(ctx) (xDAMsgFlush(ctx), xDAMEncChar(ctx,xDAMsgStep_CODE))
#define xDAMsgStepEnd(ctx) xDAMsgFlush(ctx)

#define xDAMsgRTPBegin(ctx) (xDAMsgFlush(ctx), xDAMEncChar(ctx,xDAMsgRTP_CODE))
#define xDAMsgRTPEnd(ctx) xDAMsgFlush(ctx)

/*
Temporary buffer handling:
make it possible to use xDAMEnc*** functions, and get encoded result
to insert it in an other buffer (e.g. MSC trace buffer).
Note that user is responsible to avoid calls to Flush, etc...
*/
extern void xDAMsgStartTmpBuf(xDAMsgCtx *ctx);
extern void xDAMsgEndTmpBuf(xDAMsgCtx *ctx);
extern const char * xDAMsgTmpResult(xDAMsgCtx *ctx, int *length); /* to be called before xDAMsgEndTmpBuf() */

#else
/******************************************************************************/
/* Debug Instrument side */

/*----------------------------------------------------------------------------*/
/* encoding */

/* identifier of a command (a request), build by the debugger side,
repeated in the reply to the request
*/
typedef const char *ReqId;

/* utilities to build a command from bits */
/* hide the implementation (could be sending on the fly or when complete) */
typedef struct DbgReqCtx_struct DbgReqCtx;
extern DbgReqCtx *DbgReqCmd_Start(ReqId reqid);
extern DbgReqCtx *DbgReq_Start(ReqId reqid,int kind);
extern int/*xbool*/ DbgReq_Send(DbgReqCtx **pctx,struct DbgComCtx *comctx);
extern void DbgReq_AddChar(DbgReqCtx *ctx,char c);
extern void DbgReq_AddStr(DbgReqCtx *ctx,const char *str);

/*----------------------------------------------------------------------------*/
/* decoding */

extern void DbgMsg_Decode(void);

/******************************************************************************/
#endif

#ifdef DEBUG_INSTRUMENT_SIDE
#ifdef __cplusplus
}
#endif
#endif


