/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/*******************************************************************/
/* messages (requests) from Debug Instrument (debugger) to Debug Agent (kernel) */

#define xDAReqSync	'y' /* ask for an acknowledgement message */
#define xDAReqCmd	'-' /* SDT textual command */
#define xDAReqGetVal	'v'
#define xDAReqSetVal	's'
#define xDAReqGetInstances	'i'
#define xDAReqBreak	'b' /* break execution */
#define xDAReqAck	'a' /* acknowledgement to xDAMsgSync_CODE (not a request, but let us keep naming rule) */
#define xDAReqTrack	't' /* track current position or state of given entity */
#define xDAReqCoverage	'C' /* update coverage information */
#define xDAReqNew	'n' /* create an object */
#define xDAReqDelete	'd' /* delete an object */
#define xDAReqRearrange	'r' /* rearrange elements of an object */
#define xDAReqOutput	'o' /* send a signal */
#define xDAReqBreakPoint	'B' /* set or reset a breakpoint */
#define xDAReqTrace	'T' /* configure execution traces */
#define xDAReqContinue	'c' /* continue execution after RTP */

/* name of the "ReadyQueue" object (kernel scheduler data) */
#define DBG_READYQUEUE_NAME "ReadyQueue"
/* name of the "TimerQueue" object (kernel timer scheduler data) */
#define DBG_TIMERQUEUE_NAME "TimerQueue"
/* name of the call stack object */
#define DBG_STACK_NAME "CallStack"
/* name of the message queue (input port) object */
#define DBG_MESSAGEQUEUE_NAME "Queue"
/* name of the kind field of the message object */
#define DBG_MESSAGESIGNAL_NAME "Signal"
/* name of the sender field of the message object */
#define DBG_MESSAGESENDER_NAME "Sender"
/* name of the sender field of the message object */
#define DBG_MESSAGEPRIORITY_NAME "Priority"
/* prefix of the parameter fields of the message object */
/* (name build with prefix + index) */
#define DBG_MESSAGEPARAM_PREFIX "p"
/* name of the timeout field of the timer object */
#define DBG_TIMERTIMEOUT_NAME "Timeout"
/* name of the implicit state variable of state machines */
#define DBG_STATE_NAME "state"

/*******************************************************************/
/* messages from Debug Agent (kernel) to Debug Instrument (debugger) */

#define xDAMsgReady_CODE        'a'
#define xDAMsgBusy_CODE         'b'
#define xDAMsgTrace_CODE        'c'
#define xDAMsgAck_CODE          'd'
#define xDAMsgValue_CODE        'v'
#define xDAMsgInstances_CODE    'i'
#define xDAMsgStartMscTrace_CODE 's'
#define xDAMsgMscTrace_CODE	't'
#define xDAMsgUpdateBreakpoints_CODE	'B'
#define xDAMsgTracking_CODE	'T'
#define xDAMsgSync_CODE		'y' /* DA will wait for xDAReqAck, to limit amount of queued messages */
#define xDAMsgCoverage_CODE	'C' /* coverage information */
#define xDAMsgStep_CODE		'S' /* execution step */
#define xDAMsgRTP_CODE		'p' /* entering "run-time-prompting" loop */

/* encoding elements */

#define xDAEncAckOK_CODE  '0'
#define xDAEncAckNOK_CODE  '1'

#define xDAEncReqIDEnd_CODE  ':'

#define xDAEncSeparator_CODE  ','
#define xDAEncExternalPid_CODE  '-'

#define xDAEncGnum_CODE  '$'

#define xDAEncBeginStruct_CODE  '{'
#define xDAEncEndStruct_CODE  '}'

/* special state codes */
#define xDAEncStart_CODE  '0'
#define xDAEncRPCWait_CODE  '1'
#define xDAEncErrorState_CODE '2'

#define xDAEncAbsent_CODE 'F'
#define xDAEncPresent_CODE 'T'

#define xDAEncAddress_CODE '@'

#define xDAEncRTTI_CODE '*'

/* escape character to code the NUL character */
#define xDAEncCharEsc_CODE '-'

/* encoding of xDAMsgStep: execution step kinds */
#define xDAEncTransition 't'
#define xDAEncTimeout 'o'
#define xDAEncAnswer 'd' /* answer to a run-time-prompting */

/* sdl kinds */
#define xDAEncPackage	'K'
#define xDAEncSystem	'S'
#define xDAEncSystemtype
#define xDAEncBlock	'b'
#define xDAEncBlockType	'B'
#define xDAEncProcess	'p'
#define xDAEncProcessType 'P'
#define xDAEncService	'c'
#define xDAEncServiceType 'C'
#define xDAEncProcedure	'r'
#define xDAEncState	't'
#define xDAEncSignal	's'
#define xDAEncOperator	'o'
#define xDAEncTimer	'T'

/* encoding of xDAReqOutput: */
#define xDAEncOutputInternal	'i' /* sender is not env */
#define xDAEncOutputExternalTo	'e' /* sender is env, destination specified */
#define xDAEncOutputExternalVia	'c' /* sender is env, channel specified */
#define xDAEncOutputNone	'n'

/* encoding of xDAReqBreakPoint: */
/* action to be done: add or remove */
#define xDAEncBPAdd '1'
#define xDAEncBPDelete '0'
/* breakpoint kinds */
#define xDAEncBPAt 'a'
/* other kind of breakpoints to be defined */

/* encoding of xDAReqTrace: */
/* trace kinds */
#define xDAEncTraceGR 'G' /* GR traces */
#define xDAEncTraceMSC 'M' /* MSC traces */
#define xDAEncTraceText 'T' /* Textual traces */

/* encoding of xDAMsgRTP_CODE */
#define xDAEncRTPInfDec 'i' /* RTP of answer to informal decision */
#define xDAEncRTPAnyDec 'a' /* RTP of answer to ANY decision */
#define xDAEncRTPOperation 'o' /* RTP of operation body */
#define xDAEncRTPValue 'v' /* RTP of a value of a given type */


