#!/bin/sh
#
ulimit -S -s unlimited 2>/dev/null
if [ "$?" != "0" ]; then
    stack_size=`ulimit -S -s`
    echo "Failed to unlimit stack size, please ask your system administrator to raise stack limit"
    echo "current stack size is $stack_size"
    echo "If the stack size is too small you might get undesirable behavior."
    unset stack_size
fi
exec "$INSTALLATION_DIR/bin/vcs.exe" ${1+"$@"}
