# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:31 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
set result {}

proc CollectCalledOperations { entity } {
  global result

  if { [u2::IsKindOf $entity "CallExpr"] } {
    set op [u2::GetEntity $entity "Called"]
    if { $op != 0 } {
      lappend result $op
    }
  }
}

proc GetCalledOperations { triggeredBy timing context server agentParameters } { 
  upvar 1 $agentParameters ap
  global result

  if {![u2::IsKindOf $context "Implementation"]} {
    std::Output "Error: Expected model context is an Implementation (e.g. an OperationBody).\n"
    return
  }

  u2::MetaVisit $context CollectCalledOperations

  # Note that in case just one entity was found we must add an additional NULL entry to
  # make sure Tcl will interpret the result as a list (as opposed to one single result entity).
  if { [llength $result] > 0 } {
    set result [concat $result 0]
  }

  set $ap [lset ap 0 $result] 
}

