/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:31 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#define XSCT_CADVANCED

#define C_TRANSLATOR_2_2
#include "scttypes.h"
#ifdef XINCLUDE_HS_FILE
#include "AC.hs"
#endif
#ifdef XENV_INC
#include XENV_INC
#endif
#include "output/Class1.ifc"


#ifndef XNOGLOBALNODENUMBER
/*---+---------------------------------------------------------------
     xGlobalNodeNumber  extern
-------------------------------------------------------------------*/
#ifndef XENV_NODENUMBER
#define XENV_NODENUMBER return 1;
#endif

extern int xGlobalNodeNumber(void)
{
  /* Assign a unique global system Id to each SDL system in a cluster of systems. */
  XENV_NODENUMBER
}
#endif


#ifndef XNOINITENV
/*---+---------------------------------------------------------------
     xInitEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_INIT
#define XENV_INIT
#endif

extern void xInitEnv(void)
{
  /* Code to initialize your SDL-system environment may be inserted here */
  XENV_INIT

#ifdef XTRACE
  xPrintString("xInitEnv called\n");
#endif
}
#endif


#ifndef XNOCLOSEENV
/*---+---------------------------------------------------------------
     xCloseEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_CLOSE
#define XENV_CLOSE
#endif

extern void xCloseEnv(void)
{
  /* Code to bring down the environment in a controlled manner
     may be inserted here. */
  XENV_CLOSE

#ifdef XTRACE
  xPrintString("xCloseEnv called\n");
#endif
}
#endif


/*---+---------------------------------------------------------------
     xOutEnv  extern
-------------------------------------------------------------------*/
extern void xOutEnv( xSignalNode *SignalOut )
{
	if (((*SignalOut)->NameNode) == sig_ToEnvI_OutSignal) {
		printf("xOutEnv: Signal OutSignal received. Parameters are: %d and %s\n",
			((yPDP_sig_ToEnvI_OutSignal)(*SignalOut))->Param1->age,
			((yPDP_sig_ToEnvI_OutSignal)(*SignalOut))->Param1->name);
		/* 1. Free allocated charstring */
		xFree(&(((yPDP_sig_ToEnvI_OutSignal)(*SignalOut))->Param1->name));
		/* 2. Free rest of signal parameter */
		xFree(&(((yPDP_sig_ToEnvI_OutSignal)(*SignalOut))->Param1));
		/* 3. Free signal */
		xReleaseSignal(SignalOut); 
		return;
	}

	if (((*SignalOut)->NameNode) == sig_ToEnvI_InOutSignal) {
		printf("xOutEnv: Signal ToEnvI::InOutSignal received. Parameters are: %d and %s\n",
			((yPDP_sig_ToEnvI_InOutSignal)(*SignalOut))->Param1->age,
			((yPDP_sig_ToEnvI_InOutSignal)(*SignalOut))->Param1->name);
		/* 1. Free allocated charstring */
		xFree(&(((yPDP_sig_ToEnvI_InOutSignal)(*SignalOut))->Param1->name));
		/* 2. Free rest of signal parameter */
		xFree(&(((yPDP_sig_ToEnvI_InOutSignal)(*SignalOut))->Param1));
		/* 3. Free signal */
		xReleaseSignal(SignalOut); 
		return;
	}
}


/*---+---------------------------------------------------------------
     xInEnv  extern
-------------------------------------------------------------------*/
#ifndef XTENV
extern void xInEnv ( SDL_Time Time_for_next_event )
#else
extern SDL_Duration xInEnv ( SDL_Time Time_for_next_event )
#endif
{
	xSignalNode SignalIn;
	char * charPtr;
	static int ifInSignal=1;
	
	// xInEnv is called after each transition from the main loop, so 
	// to feed the system with a normal stream of signals we only send 
	// one signal at a time (InSignal xor InOutSignal) into the system.

	if(ifInSignal) {
		/* Signal InSignal */
		/* 1. allocate signal structure */
		SignalIn = xGetSignal(sig_FromEnvI_InSignal, xNotDefPId, xEnv);
		/* 2. allocate signal parameter */
		((yPDP_sig_FromEnvI_InSignal)(SignalIn))->Param1=xAlloc(sizeof(typ_Person));
		charPtr = (char*)xAlloc(20);
		/* 3. assign signal parameter */
		strcpy(charPtr,"THello World");
		((yPDP_sig_FromEnvI_InSignal)(SignalIn))->Param1->age=30;
		((yPDP_sig_FromEnvI_InSignal)(SignalIn))->Param1->name=charPtr;
		/* 4. send signal*/
		SDL_Output(SignalIn xSigPrioPar(xDefaultPrioSignal), (xIdNode *)0);

		ifInSignal=0;
	}
	else {
		/* Signal InOutSignal */
		/* 1. allocate signal structure */
		SignalIn = xGetSignal(sig_FromEnvI_InOutSignal, xNotDefPId, xEnv);
		/* 2. allocate signal parameter */
		((yPDP_sig_FromEnvI_InOutSignal)(SignalIn))->Param1=xAlloc(sizeof(typ_Person));
		charPtr = (char*)xAlloc(20);
		/* 3. assign signal parameter */
		strcpy(charPtr,"THello World");
		((yPDP_sig_FromEnvI_InOutSignal)(SignalIn))->Param1->age=30;
		((yPDP_sig_FromEnvI_InOutSignal)(SignalIn))->Param1->name=charPtr;
		/* 4. send signal*/
		SDL_Output(SignalIn xSigPrioPar(xDefaultPrioSignal), (xIdNode *)0);

		ifInSignal=1;
	}

#ifdef XTENV
  return SDL_Time_Lit((xint32)0,(xint32)0);
#endif

}
