# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands

proc Init {} {
	global artifactNumber 
	set artifactNumber -1 

	# contextual generation commands
	std::AddCommand -variable cmdNewCORBAIDLArtifact -name "New CORBA IDL Artifact" -statusmessage "Create new CORBA IDL artifact." -tooltip "Create new CORBA IDL artifact" -accelerator "" -imagefile "" -onactivatecommand OnNewCORBAIDLArtifact -onenablecommand OnEnableNewCORBAIDLArtifact 
	std::AddCommand -variable cmdGenerateCORBAIDL -name "Generate CORBA IDL" -statusmessage "Generate CORBA IDL based on selected element." -tooltip "Generate CORBA IDL based on selected element" -accelerator "" -imagefile "" -onactivatecommand OnGenerateCORBAIDL -onenablecommand OnEnableGenerateCORBAIDL
	std::AddCommand -variable cmdIDLFile -name "Include" -statusmessage "Apply stereotype IDLFile on selected elements." -tooltip "Apply stereotype IDLFile on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyIDLFile -onenablecommand OnEnableApplyIDLFile -oncheckcommand OnCheckApllyIDLFile 
	std::AddCommand -variable cmdArtifact -name "Artifact" -statusmessage "Apply stereotype Artifact on selected elements." -tooltip "Apply stereotype Artifact on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyArtifact -onenablecommand OnEnableApplyArtifact -oncheckcommand OnCheckApllyArtifact
	std::AddCommand -variable cmdAttribute -name "Attribute" -statusmessage "Apply stereotype Attribute on selected elements." -tooltip "Apply stereotype Attribute on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyAttribute -onenablecommand OnEnableApplyAttribute -oncheckcommand OnCheckApllyAttribute
	std::AddCommand -variable cmdBoxedValue -name "BoxedValue" -statusmessage "Apply stereotype BoxedValue on selected elements." -tooltip "Apply stereotype BoxedValue on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyBoxedValue -onenablecommand OnEnableApplyBoxedValue -oncheckcommand OnCheckApllyBoxedValue
	std::AddCommand -variable cmdComponent -name "Component" -statusmessage "Apply stereotype Component on selected elements." -tooltip "Apply stereotype Component on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyComponent -onenablecommand OnEnableApplyComponent -oncheckcommand OnCheckApllyComponent
	std::AddCommand -variable cmdComponentImpl -name "ComponentImpl" -statusmessage "Apply stereotype ComponentImpl on selected elements." -tooltip "Apply stereotype ComponentImpl on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyComponentImpl -onenablecommand OnEnableApplyComponentImpl -oncheckcommand OnCheckApllyComponentImpl 
	std::AddCommand -variable cmdConstant -name "Constant" -statusmessage "Apply stereotype Attribute on selected elements, and set isConstant to true." -tooltip "Apply stereotype Attribute on selected elements, and set isConstant to true" -accelerator "" -imagefile "" -onactivatecommand OnApplyConstant -onenablecommand OnEnableApplyConstant -oncheckcommand OnCheckApllyConstant 
	std::AddCommand -variable cmdEnum -name "Enumeration" -statusmessage "Apply stereotype Enumeration on selected elements." -tooltip "Apply stereotype Enumeration on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyEnumeration -onenablecommand OnEnableApplyEnumeration -oncheckcommand OnCheckApllyEnumeration
	std::AddCommand -variable cmdEvent -name "Event" -statusmessage "Apply stereotype Event on selected elements." -tooltip "Apply stereotype Event on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyEvent -onenablecommand OnEnableApplyEvent -oncheckcommand OnCheckApllyEvent
	std::AddCommand -variable cmdEventSink -name "EventSink" -statusmessage "Apply stereotype EventSink on selected elements." -tooltip "Apply stereotype EventSink on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyEventSink -onenablecommand OnEnableApplyEventSink -oncheckcommand OnCheckApllyEventSink 
	std::AddCommand -variable cmdEventSource -name "EventSource (publisher)" -statusmessage "Apply stereotype EventSource (publisher) on selected elements." -tooltip "Apply stereotype EventSource (publisher) on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyEventSource -onenablecommand OnEnableApplyEventSource -oncheckcommand OnCheckApllyEventSource
	std::AddCommand -variable cmdEventSourceEmits -name "EventSource (emitter)" -statusmessage "Apply stereotype EventSource (emitter) on selected elements." -tooltip "Apply stereotype EventSource (emitter) on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyEventSourceEmits -onenablecommand OnEnableApplyEventSourceEmits -oncheckcommand OnCheckApllyEventSourceEmits
	std::AddCommand -variable cmdException -name "Exception" -statusmessage "Apply stereotype Exception on selected elements." -tooltip "Apply stereotype Exception on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyException -onenablecommand OnEnableApplyException -oncheckcommand OnCheckApllyException
	std::AddCommand -variable cmdFacet -name "Facet" -statusmessage "Apply stereotype Facet on selected elements." -tooltip "Apply stereotype Facet on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyFacet -onenablecommand OnEnableApplyFacet -oncheckcommand OnCheckApllyFacet
	std::AddCommand -variable cmdFactory -name "Factory" -statusmessage "Apply stereotype Factory on selected elements." -tooltip "Apply stereotype Factory on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyFactory -onenablecommand OnEnableApplyFactory -oncheckcommand OnCheckApllyFactory
	std::AddCommand -variable cmdFinder -name "Finder" -statusmessage "Apply stereotype Finder on selected elements." -tooltip "Apply stereotype Finder on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyFinder -onenablecommand OnEnableApplyFinder -oncheckcommand OnCheckApllyFinder
	std::AddCommand -variable cmdHome -name "Home" -statusmessage "Apply stereotype Home on selected elements." -tooltip "Apply stereotype Home on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyHome -onenablecommand OnEnableApplyHome -oncheckcommand OnCheckApllyHome
	std::AddCommand -variable cmdHomeImpl -name "HomeImpl" -statusmessage "Apply stereotype HomeImpl on selected elements." -tooltip "Apply stereotype HomeImpl on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyHomeImpl -onenablecommand OnEnableApplyHomeImpl -oncheckcommand OnCheckApllyHomeImpl
	std::AddCommand -variable cmdImplements -name "Implements" -statusmessage "Apply stereotype Implements on selected elements." -tooltip "Apply stereotype Implements on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyImplements -onenablecommand OnEnableApplyImplements -oncheckcommand OnCheckApllyImplements
	std::AddCommand -variable cmdInclude -name "Include" -statusmessage "Apply stereotype Include on selected elements." -tooltip "Apply stereotype Include on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyInclude -onenablecommand OnEnableApplyInclude -oncheckcommand OnCheckApllyInclude
	std::AddCommand -variable cmdInterface -name "Interface" -statusmessage "Apply stereotype Interface on selected elements." -tooltip "Apply stereotype Interface on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyInterface -onenablecommand OnEnableApplyInterface -oncheckcommand OnCheckApllyInterface
	std::AddCommand -variable cmdIsProvidedBy -name "IsProvidedBy" -statusmessage "Apply stereotype IsProvidedBy on selected elements." -tooltip "Apply stereotype IsProvidedBy on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyIsProvidedBy -onenablecommand OnEnableApplyIsProvidedBy -oncheckcommand OnCheckApllyIsProvidedBy
	std::AddCommand -variable cmdManages -name "Manages" -statusmessage "Apply stereotype Manages on selected elements." -tooltip "Apply stereotype Manages on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyManages -onenablecommand OnEnableApplyManages -oncheckcommand OnCheckApllyManages
	std::AddCommand -variable cmdModule -name "Module" -statusmessage "Apply stereotype Module on selected elements." -tooltip "Apply stereotype Module on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyModule -onenablecommand OnEnableApplyModule -oncheckcommand OnCheckApllyModule
	std::AddCommand -variable cmdOperation -name "Operation" -statusmessage "Apply stereotype Operation on selected elements." -tooltip "Apply stereotype Operation on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyOperation -onenablecommand OnEnableApplyOperation -oncheckcommand OnCheckApllyOperation	
	std::AddCommand -variable cmdPrimaryKey -name "PrimaryKey" -statusmessage "Apply stereotype PrimaryKey on selected elements." -tooltip "Apply stereotype PrimaryKey on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyPrimaryKey -onenablecommand OnEnableApplyPrimaryKey -oncheckcommand OnCheckApllyPrimaryKey
	std::AddCommand -variable cmdReceptacle -name "Receptacle" -statusmessage "Apply stereotype Receptacle on selected elements." -tooltip "Apply stereotype Receptacle on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyReceptacle -onenablecommand OnEnableApplyReceptacle -oncheckcommand OnCheckApllyReceptacle
	std::AddCommand -variable cmdReceptacleMultiple -name "Receptacle (multiple)" -statusmessage "Apply stereotype Receptacle (multiple) on selected elements." -tooltip "Apply stereotype Receptacle (multiple) on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyReceptacleMultiple -onenablecommand OnEnableApplyReceptacleMultiple -oncheckcommand OnCheckApllyReceptacleMultiple
	std::AddCommand -variable cmdSegment -name "Segment" -statusmessage "Apply stereotype Segment on selected elements." -tooltip "Apply stereotype Segment on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplySegment -onenablecommand OnEnableApplySegment -oncheckcommand OnCheckApllySegment
	std::AddCommand -variable cmdSequence -name "Sequence" -statusmessage "Apply stereotype Sequence on selected elements." -tooltip "Apply stereotype Sequence on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplySequence -onenablecommand OnEnableApplySequence -oncheckcommand OnCheckApllySequence
	std::AddCommand -variable cmdStruct -name "Struct" -statusmessage "Apply stereotype Struct on selected elements." -tooltip "Apply stereotype Struct on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyStruct -onenablecommand OnEnableApplyStruct -oncheckcommand OnCheckApllyStruct
	std::AddCommand -variable cmdSupports -name "Supports" -statusmessage "Apply stereotype Supports on selected elements." -tooltip "Apply stereotype Supports on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplySupports -onenablecommand OnEnableApplySupports -oncheckcommand OnCheckApllySupports
	std::AddCommand -variable cmdTruncatable -name "Truncatable" -statusmessage "Apply stereotype Truncatable on selected elements." -tooltip "Apply stereotype Truncatable on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyTruncatable -onenablecommand OnEnableApplyTruncatable -oncheckcommand OnCheckApllyTruncatable
	std::AddCommand -variable cmdTypedef -name "Typedef" -statusmessage "Apply stereotype Typedef on selected elements." -tooltip "Apply stereotype Typedef on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyTypedef -onenablecommand OnEnableApplyTypedef -oncheckcommand OnCheckApllyTypedef
	std::AddCommand -variable cmdUnion -name "Union" -statusmessage "Apply stereotype Union on selected elements." -tooltip "Apply stereotype Union on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyUnion -onenablecommand OnEnableApplyUnion -oncheckcommand OnCheckApllyUnion
	std::AddCommand -variable cmdUnionSimple -name "Union (simple)" -statusmessage "Apply stereotype Union (simple) on selected elements." -tooltip "Apply stereotype Union (simple) on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyUnionSimple -onenablecommand OnEnableApplyUnionSimple -oncheckcommand OnCheckApllyUnionSimple
	std::AddCommand -variable cmdUnionCase -name "Union case" -statusmessage "Apply stereotype case on selected elements." -tooltip "Apply stereotype Union case on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyUnionCase -onenablecommand OnEnableApplyUnionCase -oncheckcommand OnCheckApllyUnionCase
	std::AddCommand -variable cmdUnionDiscriminator -name "Union discriminator" -statusmessage "Apply stereotype discriminator on selected elements." -tooltip "Apply stereotype Union discriminator on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyUnionDiscriminator -onenablecommand OnEnableApplyUnionDiscriminator -oncheckcommand OnCheckApllyUnionDiscriminator
	std::AddCommand -variable cmdValue -name "Value" -statusmessage "Apply stereotype Value on selected elements." -tooltip "Apply stereotype Value on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyValue -onenablecommand OnEnableApplyValue -oncheckcommand OnCheckApllyValue
	std::AddCommand -variable cmdValueFactory -name "ValueFactory" -statusmessage "Apply stereotype ValueFactory on selected elements." -tooltip "Apply stereotype ValueFactory on selected elements" -accelerator "" -imagefile "" -onactivatecommand OnApplyValueFactory -onenablecommand OnEnableApplyValueFactory -oncheckcommand OnCheckApllyValueFactory
    
	# menu definitions
	std::AddContextMenu -variable cmCORBAIDL -commands { "separator" cmdNewCORBAIDLArtifact cmdGenerateCORBAIDL } -onenablemenu OnEnableCORBAIDL
	std::AddMenu -variable mCORBAIDL -commands { cmdAttribute cmdBoxedValue cmdConstant cmdEnum cmdException cmdIDLFile cmdInclude cmdInterface cmdModule cmdOperation cmdSequence cmdStruct cmdTruncatable cmdTypedef cmdUnion cmdUnionSimple cmdUnionCase cmdUnionDiscriminator cmdValue cmdValueFactory "separator" cmdNewCORBAIDLArtifact cmdGenerateCORBAIDL } -path { &CORBA } -position last
	std::AddMenu -variable mCCMIDL -commands { cmdArtifact cmdComponent cmdComponentImpl cmdEvent cmdEventSink cmdEventSource cmdEventSourceEmits cmdFacet cmdFactory cmdFinder cmdHome cmdHomeImpl cmdImplements cmdManages cmdPrimaryKey cmdReceptacle cmdReceptacleMultiple cmdSegment cmdSupports } -path { CC&M } -position last 
}


####################################################
# OnEnable
#################################################### 

proc OnEnableCORBAIDL { cmd } {
	# check that selection is in model view tab ("u2") and also valid
	if { ($cmd != "u2") || ! [ValidSelection] } {
		#disable CORBA IDL generation
		return 0
	}

	# enable menu commands to be shown
	return 1
}


proc OnEnableNewCORBAIDLArtifact { cmd } {
	set selected [std::GetSelection]
	
	# only single element must be selected
	if { (1 != [llength $selected]) } {
		# invalid selection
		return 0
	}

	# element must be a UML element ("U2") 
	# note that GetKind is an UNSUPPORTED TCL command
	set element [lindex $selected 0]
	if { ("" == $element) || ("U2" != [GetKind $element]) } {
		# invalid selection
		return 0
	}

	# selection must be of a valid kind (Package, Class or Interface)
	if { ! ([u2::IsKindOf $element "Package"] || [u2::IsKindOf $element "Class"] || [u2::IsKindOf $element "Interface"] ) } {
		# invalid selection
		return 0
	}
	
    # enable menu command "New CORBA IDL artifact"
	return 1
}


proc OnEnableGenerateCORBAIDL { cmd } {
	set element [lindex [std::GetSelection] 0]

	# element must be a UML element ("U2") 
	if { ("" == $element) || ("U2" != [GetKind $element]) } {
		# invalid selection
		return 0
	}
	
	# only enable command if selected element is an artifact
	if { ![u2::IsKindOf $element "Artifact"] } {
		#disable menu command
		return 0
	}

	# only enable command if selected artifact is marked with proper IDL stereotype
	set idlArtifact [u2::GetTaggedValue $element "IDLGenerator (. .)"]

	if { (0 == $idlArtifact) } {
		#disable menu command
		return 0
	}

	# enable menu command "Generate CORBA IDL"
	return 1
}


proc OnEnableModelElement { metaclass } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid
	foreach element $elements {
		# element must be a UML element ("U2")
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		if { ! [u2::IsKindOf $element $metaclass] } {
			return 0
		}
	}

	# enable menu command
	return 1
}


proc OnEnableApplyArtifact { cmd } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid
	foreach element $elements {
		# element must be a UML element ("U2") 
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		if { ! ([u2::IsKindOf $element "Class"] || [u2::IsKindOf $element "Artifact"]) } {
			return 0
		}
	}
	
	# enable menu command
	return 1
}

proc OnEnableApplyArtifact { cmd } {	
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyAttribute { cmd } {	
	return [OnEnableModelElement "Attribute"]
}


proc OnEnableApplyBoxedValue { cmd } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid 
	foreach element $elements {
		# element must be a UML element ("U2") 
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		# use classifier instead of following list?
		if { ! ([u2::IsKindOf $element "Class"] || [u2::IsKindOf $element "Syntype"]) } {
			return 0
		}
	}
	
	# enable menu command
	return 1
}


proc OnEnableApplyComponent { cmd } {	
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyComponentImpl { cmd } {	
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyConstant { cmd } {	
	return [OnEnableModelElement "Attribute"]
}


proc OnEnableApplyEnumeration { cmd } {
	return [OnEnableModelElement "DataType"]
}


proc OnEnableApplyEvent { cmd } {
	return [OnEnableModelElement "Interface"]
}


proc OnEnableApplyEventSink { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplyEventSource { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplyEventSourceEmits { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplyException { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyFacet { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplyFactory { cmd } {
	return [OnEnableModelElement "Operation"]
}


proc OnEnableApplyFinder { cmd } {
	return [OnEnableModelElement "Operation"]
}


proc OnEnableApplyHome { cmd } {
    return [OnEnableModelElement "Interface"]
}


proc OnEnableApplyHomeImpl { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyIDLFile { cmd } {
	return [OnEnableModelElement "Artifact"]
}


proc OnEnableApplyImplements { cmd } {
	return [OnEnableModelElement "Dependency"]
}


proc OnEnableApplyInclude { cmd } {
	return [OnEnableModelElement "Dependency"]
}


proc OnEnableApplyInterface { cmd } {
	return [OnEnableModelElement "Interface"]
}


proc OnEnableApplyIsProvidedBy { cmd } {
	return [OnEnableModelElement "Dependency"]
}


proc OnEnableApplyManages { cmd } {
	return [OnEnableModelElement "Dependency"]
}


proc OnEnableApplyModule { cmd } {
	return [OnEnableModelElement "Package"]
}


proc OnEnableApplyOperation { cmd } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid
	foreach element $elements {
		# element must be a UML element ("U2") 
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		if { ! ([u2::IsKindOf $element "Operation"] || [u2::IsKindOf $element "Signal"]) } {
			return 0
		}
	}
	
	# enable menu command
	return 1
}


proc OnEnableApplyPrimaryKey { cmd } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid
	foreach element $elements {
		# element must be a UML element ("U2") 
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		if { ! ([u2::IsKindOf $element "Association"] || [u2::IsKindOf $element "Dependency"]) } {
			return 0
		}
	}
	
	# enable menu command
	return 1
}


proc OnEnableApplyReceptacle { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplyReceptacleMultiple { cmd } {
	return [OnEnableModelElement "Port"]
}


proc OnEnableApplySegment { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplySequence { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyStruct { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplySupports { cmd } {
	return [OnEnableModelElement "Generalization"]
}


proc OnEnableApplyTruncatable { cmd } {
	return [OnEnableModelElement "Generalization"]
}


proc OnEnableApplyTypedef { cmd } {
	set elements [std::GetSelection]

	# only enable command if all selected elements are valid 
	foreach element $elements {
		# element must be a UML element ("U2") 
		if { ("" == $element) || ("U2" != [GetKind $element]) } {
			# invalid selection
			return 0
		}

		# valid model elements
		# use classifier instead of following list?
		if { ! ([u2::IsKindOf $element "Class"] || [u2::IsKindOf $element "Syntype"] || [u2::IsKindOf $element "DataType"] || [u2::IsKindOf $element "Interface"]) } {
			return 0
		}
	}
	
	# enable menu command
	return 1
}


proc OnEnableApplyUnion { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyUnionSimple { cmd } {
	return [OnEnableModelElement "Class"]
}


proc OnEnableApplyUnionCase { cmd } {
	return [OnEnableModelElement "Attribute"]
}


proc OnEnableApplyUnionDiscriminator { cmd } {
	return [OnEnableModelElement "Attribute"]
}


proc OnEnableApplyValue { cmd } {
	return [OnEnableModelElement "Interface"]
}


proc OnEnableApplyValueFactory { cmd } {
	return [OnEnableModelElement "Operation"]
}


####################################################
# OnActivate
####################################################

proc OnGenerateCORBAIDL { cmd } {
	set artifact [lindex [std::GetSelection] 0]
	
	# invoke C++ agent to generate IDL
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set agent [u2::FindByGuid $model "@Agent@IDLExporter"]
	if { 0 == $agent } {
		std::Output "Failed to find IDL exporter agent\n"
		# failed to find agent
		return 0
	}
	if { [catch {
	  u2::InvokeAgent $model $agent $artifact
	} e ] } {
		std::Output "Error when invoking IDL exporter agent\n"
	}
	return 1
}


proc OnNewCORBAIDLArtifact { cmd } {
	global artifactNumber

	set element [lindex [std::GetSelection] 0]
	set elementName [u2::GetValue $element "Name"]
	set owner [u2::GetEntity $element "owner"]
	
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set artifactName "IDLArtifact$elementName[ArtifactNumber]"
	
	# create artifact
	set artifact [u2::Create $owner "Artifact"]
	u2::SetValue $artifact "Name" $artifactName

	# apply IDL stereotype to artifact
	set stereotype [u2::FindByGuid $model "@CORBA@IDL"]
        set marker [u2::ApplyStereotype $artifact $stereotype "fullQualifier"]

	# create dependency
	set dependency [u2::New $model "Dependency"]
	u2::SetEntity $artifact "ClientDependency" $dependency
	u2::SetEntity $dependency "Supplier" $element	

	# apply manifest stereotype to dependency
	set stereotype [u2::FindByGuid $model "@Predefined@manifest"]
        set marker [u2::ApplyStereotype $dependency $stereotype "fullQualifier"]

	return 1
}


proc OnApplyModelElement { guid } {
	set elements [std::GetSelection]

	# find stereotype
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set stereotype [u2::FindByGuid $model $guid]

	# apply stereotype
	foreach element $elements {
	    u2::ApplyStereotype $element $stereotype "fullQualifier"
	}
		
	return 1
}


proc OnApplyArtifact { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Artifact"] ) } {
		return [OnApplyModelElement "@CORBA@Artifact"]
	}
	return [DeleteAppliedStereotype "CORBAArtifact"]
}


proc OnApplyAttribute { cmd } {
        if { ([OnCheckApllyAttribute $cmd]) } {
	    return [DeleteAppliedStereotype "CORBAAttribute"]   
	}
	
	if { ([OnCheckApllyConstant $cmd]) } {
	    DeleteAppliedStereotype "CORBAAttribute"
	}

	set elements [std::GetSelection]

	# find stereotype
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set stereotype [u2::FindByGuid $model "@CORBA@Attribute"]

	# apply stereotype
	foreach element $elements {
	    set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
		u2::SetTaggedValue $element "CORBAAttribute (. isConstant .)" "false"
	}
		
	return 1
}

proc OnApplyBoxedValue { cmd } {
        if { !( [OnCheckAppliedStereotype "@CORBA@BoxedValue"] ) } {
		return [OnApplyModelElement "@CORBA@BoxedValue"]
	}
	return [DeleteAppliedStereotype "CORBABoxedValue"]
}


proc OnApplyComponent { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Component"] ) } {
		return [OnApplyModelElement "@CORBA@Component"]
	}
	return [DeleteAppliedStereotype "CORBAComponent"]
}


proc OnApplyComponentImpl { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@ComponentImpl"] ) } {
		return [OnApplyModelElement "@CORBA@ComponentImpl"]
	}
	return [DeleteAppliedStereotype "CORBAComponentImpl"]
}


proc OnApplyConstant { cmd } {
        if { ( [OnCheckApllyConstant $cmd] ) } {
	    return [DeleteAppliedStereotype "CORBAAttribute"]
	}
	
	if { ([OnCheckApllyAttribute $cmd]) } {
	    DeleteAppliedStereotype "CORBAAttribute"
	}
	
	set elements [std::GetSelection]

	# find stereotype
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set stereotype [u2::FindByGuid $model "@CORBA@Attribute"]

	# apply stereotype
	foreach element $elements {
	    set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
		u2::SetTaggedValue $element "CORBAAttribute (. isConstant .)" "true"
	}
		
	return 1
}


proc OnApplyEnumeration { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Enum"] ) } {
		return [OnApplyModelElement "@CORBA@Enum"]
	}
	return [DeleteAppliedStereotype "CORBAEnum"]
}


proc OnApplyEvent { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Event"] ) } {
		return [OnApplyModelElement "@CORBA@Event"]
	}
	return [DeleteAppliedStereotype "CORBAEvent"]
}


proc OnApplyEventSink { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@EventSink"] ) } {
		return [OnApplyModelElement "@CORBA@EventSink"]
	}
	return [DeleteAppliedStereotype "CORBAEventSink"]
}


proc OnApplyEventSource { cmd } {
	if { ([OnCheckApllyEventSource $cmd]) } {
	    return [DeleteAppliedStereotype "CORBAEventSource"]   
	}
	
	if { ([OnCheckApllyEventSourceEmits $cmd]) } {
	    DeleteAppliedStereotype "CORBAEventSource"
	}
	
	return [OnApplyModelElement "@CORBA@EventSource"]
}


proc OnApplyEventSourceEmits { cmd } {
        if { ( [OnCheckApllyEventSourceEmits $cmd] ) } {
	    return [DeleteAppliedStereotype "CORBAEventSource"]
	}
	
	if { ([OnCheckApllyEventSource $cmd]) } {
	    DeleteAppliedStereotype "CORBAEventSource"
	}
	
	set elements [std::GetSelection]

	# find stereotype
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set stereotype [u2::FindByGuid $model "@CORBA@EventSource"]

	# apply stereotype
	foreach element $elements {
	    set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
		u2::SetTaggedValue $element "CORBAEventSource (. sourceKind .)" "Emitter"
	}
		
	return 1
}


proc OnApplyException { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Exception"] ) } {
		return [OnApplyModelElement "@CORBA@Exception"]
	}
	return [DeleteAppliedStereotype "CORBAException"]
}


proc OnApplyFacet { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Facet"] ) } {
		return [OnApplyModelElement "@CORBA@Facet"]
	}
	return [DeleteAppliedStereotype "CORBAFacet"]
}


proc OnApplyFactory { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Factory"] ) } {
		return [OnApplyModelElement "@CORBA@Factory"]
	}
	return [DeleteAppliedStereotype "CORBAFactory"]
}


proc OnApplyFinder { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Finder"] ) } {
		return [OnApplyModelElement "@CORBA@Finder"]
	}
	return [DeleteAppliedStereotype "CORBAFinder"]
}


proc OnApplyHome { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Home"] ) } {
		return [OnApplyModelElement "@CORBA@Home"]
	}
	return [DeleteAppliedStereotype "CORBAHome"]
}


proc OnApplyHomeImpl { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@HomeImpl"] ) } {
		return [OnApplyModelElement "@CORBA@HomeImpl"]
	}
	return [DeleteAppliedStereotype "CORBAHomeImpl"]
}


proc OnApplyIDLFile { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@IDLFile"] ) } {
		return [OnApplyModelElement "@CORBA@IDLFile"]
	}
	return [DeleteAppliedStereotype "CORBAIDLFile"]
}


proc OnApplyImplements { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Implements"] ) } {
		return [OnApplyModelElement "@CORBA@Implements"]
	}
	return [DeleteAppliedStereotype "CORBAImplements"]
}


proc OnApplyInclude { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Include"] ) } {
		return [OnApplyModelElement "@CORBA@Include"]
	}
	return [DeleteAppliedStereotype "CORBAInclude"]
}


proc OnApplyInterface { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Interface"] ) } {
		return [OnApplyModelElement "@CORBA@Interface"]
	}
	return [DeleteAppliedStereotype "CORBAInterface"]
}


proc OnApplyIsProvidedBy { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@IsProvidedBy"] ) } {
		return [OnApplyModelElement "@CORBA@IsProvidedBy"]
	}
	return [DeleteAppliedStereotype "CORBAIsProvidedBy"]
}


proc OnApplyManages { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Manages"] ) } {
		return [OnApplyModelElement "@CORBA@Manages"]
	}
	return [DeleteAppliedStereotype "CORBAManages"]
}


proc OnApplyModule { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Module"] ) } {
		return [OnApplyModelElement "@CORBA@Module"]
	}
	return [DeleteAppliedStereotype "CORBAModule"]
	
}


proc OnApplyOperation { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Operation"] ) } {
		return [OnApplyModelElement "@CORBA@Operation"]
	}
	return [DeleteAppliedStereotype "CORBAOperation"]
}


proc OnApplyPrimaryKey { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@PrimaryKey"] ) } {
		return [OnApplyModelElement "@CORBA@PrimaryKey"]
	}
	return [DeleteAppliedStereotype "CORBAPrimaryKey"]
}


proc OnApplyReceptacle { cmd } {
        if { ([OnCheckApllyReceptacle $cmd]) } {
	    return [DeleteAppliedStereotype "CORBAReceptacle"]   
	}
	
	if { ([OnCheckApllyReceptacleMultiple $cmd]) } {
	    DeleteAppliedStereotype "CORBAReceptacle"
	}
	return [OnApplyModelElement "@CORBA@Receptacle"]
}


proc OnApplyReceptacleMultiple { cmd } {
        if { ( [OnCheckApllyReceptacleMultiple $cmd] ) } {
	    return [DeleteAppliedStereotype "CORBAReceptacle"]
	}
	
	if { ([OnCheckApllyReceptacle $cmd]) } {
	    DeleteAppliedStereotype "CORBAReceptacle"
	}

	set elements [std::GetSelection]

	# find stereotype
	set curProject [std::GetActiveProject]
	set model [std::GetModels -kind "U2" -project $curProject]
	set stereotype [u2::FindByGuid $model "@CORBA@Receptacle"]

	# apply stereotype
	foreach element $elements {
	    set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
		u2::SetTaggedValue $element "CORBAReceptacle (. isMultiple .)" "true"
	}
		
	return 1
}


proc OnApplySegment { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Segment"] ) } {
		return [OnApplyModelElement "@CORBA@Segment"]
	}
	return [DeleteAppliedStereotype "CORBASegment"]
}


proc OnApplySequence { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Sequence"] ) } {
		return [OnApplyModelElement "@CORBA@Sequence"]
	}
	return [DeleteAppliedStereotype "CORBASequence"]
}


proc OnApplyStruct { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Struct"] ) } {
		return [OnApplyModelElement "@CORBA@Struct"]
	}
	return [DeleteAppliedStereotype "CORBAStruct"]
}


proc OnApplySupports { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Supports"] ) } {
		return [OnApplyModelElement "@CORBA@Supports"]
	}
	return [DeleteAppliedStereotype "CORBASupports"]
}


proc OnApplyTruncatable { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Truncatable"] ) } {
		return [OnApplyModelElement "@CORBA@Truncatable"]
	}
	return [DeleteAppliedStereotype "CORBATruncatable"]
}


proc OnApplyTypedef { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@Typedef"] ) } {
		return [OnApplyModelElement "@CORBA@Typedef"]
	}
	return [DeleteAppliedStereotype "CORBATypedef"]
}


proc OnApplyUnion { cmd } {
	if { ([OnCheckApllyUnion $cmd]) } {
	    return [DeleteAppliedStereotype "CORBAUnion"]   
	}
	
	if { ([OnCheckApllyUnionSimple $cmd]) } {
	    DeleteAppliedStereotype "CORBAUnion"
	}
	
	return [OnApplyModelElement "@CORBA@Union"]
}


proc OnApplyUnionSimple { cmd } {
	if { ( [OnCheckApllyUnionSimple $cmd] ) } {
	    return [DeleteAppliedStereotype "CORBAUnion"]
	}
	
	if { ([OnCheckApllyUnion $cmd]) } {
	    DeleteAppliedStereotype "CORBAUnion"
	}
	
        set elements [std::GetSelection]

        # find stereotype
        set curProject [std::GetActiveProject]
        set model [std::GetModels -kind "U2" -project $curProject]
        set stereotype [u2::FindByGuid $model "@CORBA@Union"]

        # apply stereotype
        foreach element $elements {
            set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
    	    u2::SetTaggedValue $element "CORBAUnion (. isSimple .)" "true"
        }
        return 1
}


proc OnApplyUnionCase { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@case"] ) } {
		return [OnApplyModelElement "@CORBA@case"]
	}
	return [DeleteAppliedStereotype "'case'"]
}


proc OnApplyUnionDiscriminator { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@discriminator"] ) } {
		return [OnApplyModelElement "@CORBA@discriminator"]
	}
	return [DeleteAppliedStereotype "discriminator"]
}


proc OnApplyValue { cmd } {
	if { !([OnCheckAppliedStereotype "@CORBA@Value"]) } {
	
	    set elements [std::GetSelection]

	    # find stereotype
	    set curProject [std::GetActiveProject]
	    set model [std::GetModels -kind "U2" -project $curProject]
	    set stereotype [u2::FindByGuid $model "@CORBA@Value"]

	    # apply stereotype
	    foreach element $elements {
	        set marker [u2::ApplyStereotype $element $stereotype "fullQualifier"]	
		    u2::SetTaggedValue $element "CORBAValue (. isCustom .)" "false"
	    }
		
	    return 1
        }
        return [DeleteAppliedStereotype "CORBAValue"]
}


proc OnApplyValueFactory { cmd } {
	if { !( [OnCheckAppliedStereotype "@CORBA@ValueFactory"] ) } {
		return [OnApplyModelElement "@CORBA@ValueFactory"]
	}
	return [DeleteAppliedStereotype "CORBAValueFactory"]
}

###################################################
# OnCheckApply procedures
###################################################
proc OnCheckAppliedStereotype { cmd } {
 	set selected [std::GetSelection]
	if { (1 != [llength $selected]) } {
	 	# invalid selection
		return 0
	}
	set element [lindex $selected 0]
	# element must be a UML element ("U2") 
	if { ("" == $element) || ("U2" != [GetKind $element]) } {
		# invalid selection
		return 0
	}
	# check that element has this stereotype applied
	return [u2::HasAppliedStereotype $element $cmd -guid 1]
}

proc DeleteAppliedStereotype { pattern } {
        set selected [std::GetSelection]
	if { (1 != [llength $selected]) } {
	 	# invalid selection
		return 0
	}
	set element [lindex $selected 0]
	# element must be a UML element ("U2") 
	if { ("" == $element) || ("U2" != [GetKind $element]) } {
		# invalid selection
		return 0
	}
        
        set cont 1
        while {$cont} {
                set cont 0
                set si [u2::GetTaggedValue $element "$pattern (. .)"]
				if [IsElementRef $si] {
                        Delete $si
                        set cont 1
                }
        }
}

proc IsElementRef {e} {
  if {($e == 0) || ($e == "")} {
    return 0
  }
  return 1
}

proc GetTaggedValueAsString { element pattern } {
	if { $element == 0 || $pattern == "" } {
		return ""
	}
	
	set taggedValue [u2::GetTaggedValue $element $pattern]

	set metaclassName ""
	if { [catch { set metaclassName [u2::GetMetaClassName $taggedValue] } e ]} {
		# not entity => string
		return $taggedValue
	}
	if { $metaclassName == "Ident" } {
		return [u2::GetValue $taggedValue Name]
	}
	
	return ""
}


proc OnCheckApllyArtifact { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Artifact"]
}

proc OnCheckApllyAttribute { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Attribute" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAAttribute (. isConstant .)"]} {
        return 0
    } else {
        return 1
    }    
}

proc OnCheckApllyBoxedValue { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@BoxedValue"]
}

proc OnCheckApllyComponent { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Component"]
}

proc OnCheckApllyComponentImpl { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@ComponentImpl"]
}

proc OnCheckApllyConstant { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Attribute" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAAttribute (. isConstant .)"]} {
        return 1
    } else {
        return 0
    }    
}

proc OnCheckApllyEnumeration { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Enum"]
}

proc OnCheckApllyEvent { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Event"]
}

proc OnCheckApllyEventSink { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@EventSink"]
}

proc OnCheckApllyEventSource { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@EventSource" -guid 1] ) } {
        return 0
    }
    
    if {"Emitter" == [GetTaggedValueAsString $element "CORBAEventSource (. sourceKind .)"]} {
        return 0
    } else {
        return 1
    }    
}

proc OnCheckApllyEventSourceEmits { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@EventSource" -guid 1] ) } {
        return 0
    }
    
    if {"Emitter" == [GetTaggedValueAsString $element "CORBAEventSource (. sourceKind .)"]} {
        return 1
    } else {
        return 0
    }    
}

proc OnCheckApllyException { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Exception"]
}

proc OnCheckApllyFacet { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Facet"]
}

proc OnCheckApllyFactory { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Factory"]
}

proc OnCheckApllyFinder { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Finder"]
}

proc OnCheckApllyHome { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Home"]
}

proc OnCheckApllyHomeImpl { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@HomeImpl"]
}

proc OnCheckApllyIDLFile { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@IDLFile"]
}

proc OnCheckApllyImplements { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Implements"]
}

proc OnCheckApllyInclude { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Include"]
}

proc OnCheckApllyInterface { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Interface"]
}

proc OnCheckApllyIsProvidedBy { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@IsProvidedBy"]
}

proc OnCheckApllyManages { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Manages"]
}

proc OnCheckApllyModule { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Module"]
}

proc OnCheckApllyOperation { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Operation"]
}

proc OnCheckApllyPrimaryKey { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@PrimaryKey"]
}

proc OnCheckApllyReceptacle { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Receptacle" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAReceptacle (. isMultiple .)"]} {
        return 0
    } else {
        return 1
    }
}

proc OnCheckApllyReceptacleMultiple { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
 	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Receptacle" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAReceptacle (. isMultiple .)"]} {
        return 1
    } else {
        return 0
    }
}

proc OnCheckApllySegment { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Segment"]
}

proc OnCheckApllySequence { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Sequence"]
}

proc OnCheckApllyStruct { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Struct"]
}

proc OnCheckApllySupports { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Supports"]
}

proc OnCheckApllyTruncatable { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Truncatable"]
}

proc OnCheckApllyTypedef { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Typedef"]
}

proc OnCheckApllyUnion { cmd } {
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Union" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAUnion (. isSimple .)" ] } {
        return 0
    } else {
        return 1
    }
}

proc OnCheckApllyUnionSimple { cmd } {
    
    set selected [std::GetSelection]
    if { (1 != [llength $selected]) } {
 	# invalid selection
	return 0
    }
    set element [lindex $selected 0]
    # element must be a UML element ("U2") 
    if { ("" == $element) || ("U2" != [GetKind $element]) } {
	# invalid selection
	return 0
    }
    
    if { ! ( [u2::HasAppliedStereotype $element "@CORBA@Union" -guid 1] ) } {
        return 0
    }
    
    if {"true" == [GetTaggedValueAsString $element "CORBAUnion (. isSimple .)"]} {
        return 1
    } else {
        return 0
    }
}

proc OnCheckApllyUnionCase { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@case"]
}

proc OnCheckApllyUnionDiscriminator { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@discriminator"]
}

proc OnCheckApllyValue { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@Value"]
}

proc OnCheckApllyValueFactory { cmd } {
    return [OnCheckAppliedStereotype "@CORBA@ValueFactory"]
}

####################################################
# Help procedures
####################################################

proc ValidSelection {} {
	set selected [std::GetSelection]
	
	# only single element must be selected
	if { (1 != [llength $selected]) } {
		# invalid selection
		return 0
	}

	# element must be a UML element ("U2") 
	# note that GetKind is an UNSUPPORTED TCL command
	set element [lindex $selected 0]
	if { ("" == $element) || ("U2" != [GetKind $element]) } {
		# invalid selection
		return 0
	}

	# selection must be of a valid kind
	if { ! ([u2::IsKindOf $element "Package"] || [u2::IsKindOf $element "Class"] || [u2::IsKindOf $element "Interface"] || [u2::IsKindOf $element "Artifact"]) } {
		# invalid selection
		return 0
	}
	
	# selection is valid
	return 1
}


proc ArtifactNumber { } {
	global artifactNumber

	# stupid algorithm to get a unique number
	# not persistent between runs of TAU
	#	for this, apply a stereotype to the session that keeps track of the latest 
	#	created number
	if { ($artifactNumber < 10000) } {
		set artifactNumber [expr $artifactNumber + 1]
	} else {
		# start over from 0
		set artifactNumber 0
	}
	return $artifactNumber
}



####################################################

# include helper files
set addin "CORBAIDLGenerator"
# source [file join [std::GetInstallationDirectory] addins/$addin/Script/ElementSorter.tcl]

# run
Init
