/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torChoice.h
// ----------
// C++ implementation of a UML2 Choice
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_CHOICE__H__
#define __TOR_CHOICE__H__

#include "torPlatform.h"

namespace tor {

  // This exception is thrown on an attempt to read from a
  // Choice attribute that is not present.
  typedef int EChoiceAttributeNotPresent;

  // Choice representation
  template <class Union, class Kind>
  class Choice {
  public:
    Union data;
    Kind kind;

    bool isPresent(Kind k) {
      return (kind == k);
    }
  };

}


#endif // __TOR_CHOICE__H__

