/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef GEN_6bz8iLEGnslLm0BctIYmbvlI
#define GEN_6bz8iLEGnslLm0BctIYmbvlI
#include "tor.h"
#include "torCoders.h"
#include "torContainers.h"
#include "torMetaStackContext.h"

class WaitForHostCommand;
class WaitForEvent;
namespace tor {
    namespace meta {
        class EventManagerImpl_initialize;
    }
}
namespace tor {
    namespace meta {
        class TauHostDebuggerProxy;
    }
}
namespace tor {
    namespace meta {
        class EventMedia;
    }
}
namespace tor {
    namespace meta {
        /*Implementation of the EventManager!
An instrumented TOR application contains exactly one
instance of this class, running in its own thread. It is 
responsible for receiving and processing meta events
sent from the application, and debugger events sent from
a "host" debugger or from the application.
Meta events are "outgoing" and will be encoded by the registered 
Coder into a string representation. This string will then be emitted 
over all registered EventMedias.
Debugger events may be either "outgoing" or "incoming". Outgoing
debugger events will be encoded by the default coder into a string
representation which will be sent to a TauHostDebugger object. 
This object is part of the Tau host (but may be embedded in other
applications as well), and is responsible for mapping these events
into Tau tool events.*/
        class EventManagerImpl: virtual public tor::DispatchableClass {
            protected:
            os::Semaphore sem_finished;
            ThreadedDispatcher thread;
            U2P_Coder defaultCoder;
            tor::String<EventMedia *> media;
            public:
            ThreadInfos threadInfos;
            protected:
            TauHostDebuggerProxy *tauHostDebugger;
            friend class EventManager;
            ~EventManagerImpl();
            EventManagerImpl();
            typedef tor::DispatchableClass theDispatchableClass;
            public:
            virtual bool receive(tor::Event *e);
            virtual void init();
            EventManagerImpl_initialize *m_sm;
            virtual tor::StateMachine *getClassifierBehavior();
            friend class EventManagerImpl_initialize;
            friend class WaitForEvent;
            friend class WaitForHostCommand;
            virtual void start();
            tor::Port p_in;
            tor::Port p;
            protected:
            void disconnect();
        };
    }
}
#endif /*INCLUDE PROTECTION*/

