// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#ifdef TOR_USE_INSTRUMENTATION

#include "torPlatform.h"

#include "torMetaData.h"

using namespace tor::meta;

// Predefined types
PrimitiveType tor::meta::_Integer(_T("Integer"), _T("@Predefined@Integer"), 0);
PrimitiveType tor::meta::_Boolean(_T("Boolean"), _T("@Predefined@Boolean"), 0);
PrimitiveType tor::meta::_Pointer(_T("CPtr"), _T("@CppPredefined@CPtr"), 0); // Representation of general pointer

void StructuredType::getMemberValues(const void* data, StructuredValue* value) {
    currentStructuredValue = value;
    getValue(data);
    currentStructuredValue = 0;
}


Value* PrimitiveType::getValue(const void* data) {
    SimpleValue* siv = new SimpleValue(this);

    if (this == &_Integer){
	tor::Integer* p = const_cast<tor::Integer*>(reinterpret_cast<const tor::Integer*>(data));
	siv->setInteger(*p);
    }
    else if (this == &_Boolean){
	tor::Boolean* p = const_cast<tor::Boolean*>(reinterpret_cast<const tor::Boolean*>(data));
	siv->setBoolean(*p);
    }
    else if (this == &_Pointer){
	void* p = const_cast<void*>(data);
	siv->setPointer(p);
    }

    return siv;
}

void PrimitiveType::setValue(void* data, Value* value) {
    SimpleValue* siv = dynamic_cast<SimpleValue*>(value);
    if (!siv)
	return; // Expected a simple value for a primitive type

    if (this == &_Integer) {
	tor::Integer* p = const_cast<tor::Integer*>(reinterpret_cast<const tor::Integer*>(data));
	*p = siv->m_integer;
    }
    else if (this == &_Boolean) {
	tor::Boolean* p = const_cast<tor::Boolean*>(reinterpret_cast<const tor::Boolean*>(data));
	*p = siv->m_boolean;
    }
    else if (this == &_Pointer) {
	void** p = static_cast<void**>(data);
	*p = siv->m_pointer;
    }
}

SimpleValue::SimpleValue(Type* t)  : Value(t) {
    if (t == &_Integer)
    	kind = k_Integer;
    else if (t == &_Boolean)
	kind = k_Boolean;
    else if (dynamic_cast<Enumeration*>(t))
	kind = k_Identifier;
    else if (t == &_Pointer) 
	kind = k_Pointer;
}

void SimpleValue::setInteger(tor::Integer i) {
    m_integer = i;
}

void SimpleValue::setBoolean(tor::Boolean b) {
    m_boolean = b;
}

void SimpleValue::setPointer(void* p) {
    m_pointer = p;
}

void SimpleValue::setIdentifier(Definition* d) {
    m_definition = d;
}

bool SimpleValue::isInteger() const {
    return kind == k_Integer;
}

bool SimpleValue::isBoolean() const {
    return kind == k_Boolean;
}

bool SimpleValue::isPointer() const {
    return kind == k_Pointer;
}

bool SimpleValue::isIdentifier() const {
    return kind == k_Identifier;
}

//////////////////////////////////////////////////////////////////////////

namespace {
    tor::meta::Application defaultApplication;
}

tor::meta::Application* tor::meta::theApplication = &defaultApplication;

tor::meta::Application::Application(const tor::Charstring& strName, const tor::Charstring& strGuid) : Definition(strName, strGuid, 0) {   
    theApplication = this;
}

bool tor::meta::Application::isInstrumented() {
    return (theApplication != &defaultApplication);
}

#endif

