/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torThreadSafeEventQueue_h__
#define __torThreadSafeEventQueue_h__ (1)

#include "torPlatform.h"

#include "torEventQueue.h"
#include "torOs.h"

namespace tor 
{
    class Event;
    class Dispatchable;

    class TOR_EXT_DEF ThreadSafeEventQueue : public EventQueue 
    {
    public:
        ThreadSafeEventQueue();
        virtual ~ThreadSafeEventQueue();

        void insert(Event *event);
        bool remove(Event *event);        

        Event *get();
        Event *get(os::Time timeout);
        
        bool empty() const;

    private:
        mutable os::Mutex m_mutex;
        mutable os::Semaphore m_read;
    };

} // tor namespace

#endif  // __torThreadSafeEventQueue_h__

