# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ========= HTML Report Generator Addin for Tau G2 v2.4.0 =========

## TODO add netaclass name cache


proc CorrectMetaClassName { elmt } {

	# Return metaclass name of element in most cases,
	# But return more explicit names in some cases

	if { "" == $elmt || $elmt == 0 } {
		dbg::Output "************************ 0 passed into CorrectMetaClassName\n"
		return "UNKNOWN"
		carp
	}
#	dbg::Output "(Debug)\tCorrectMetaClassName!\n"



	## OPERATION ##
	if { [u2::IsKindOf $elmt Operation] } {
            if { [u2::GetTaggedValue $elmt "usecase(..)"] != 0 } {
                return UseCase
            }
            if { [u2::GetTaggedValue $elmt "'activity'(..)"] != 0 } {
                return Activity
            }
            if { [u2::GetTaggedValue $elmt "'interaction'(..)"] != 0 } {
                return Interaction
            }
	};#end_if element is an Operation
        
        # handle various implementations...
        if { [u2::IsKindOf $elmt Method] } {
            if { [u2::IsKindOf $elmt Interaction] } {
                return "InteractionImplementation"
            } elseif { [u2::IsKindOf $elmt StateMachineImplementation] } {
                return "StateMachineImplementation"
            }
        }

	## CLASS ##
	if { [u2::IsKindOf $elmt Class] } {
                if { [u2::GetTaggedValue $elmt "component(..)"] != 0 } {
                    return Component
                }
		## ACTIVE CLASS ##
		if { [u2::GetValue $elmt "IsActive"] } {
			return "ActiveClass"
		};#end_if class is active
	};#end_if element is a class

        if { [u2::IsKindOf $elmt ActivityDiagram] && [u2::GetTaggedValue $elmt "interactionOverviewDiagram(..)"] != 0 } {
            return InteractionOverviewDiagram
        }

        if { [u2::IsKindOf $elmt ClassDiagram] } {
            if { [u2::GetTaggedValue $elmt "deploymentDiagram(..)"] != 0 } { return DeploymentDiagram }
        }

	## ATTRIBUTE ##
	if { [u2::IsKindOf $elmt Attribute] } {
		## PART ##
                if { [u2::GetTaggedValue $elmt "actor(..)"] != 0 } {
                     return Actor
                }
                if { [u2::GetTaggedValue $elmt "subject(..)"] != 0 } {
                     return Subject
                }
		if { [u2::GetValue $elmt "Aggregation"] == "AkComposite" } {
			return "Part"
		};#end_if attribute is a Part


	};#end_if element is an Attribute

	## Package/Component diagrams ##
	if { [u2::IsKindOf $elmt ClassDiagram] } {
            if { [u2::GetTaggedValue $elmt "componentDiagram(..)"] != 0 } { return ComponentDiagram }
            if { [u2::GetTaggedValue $elmt "packageDiagram(..)"] != 0 } { return PackageDiagram }
	}

	## Composite structure diagram ##
	if { [u2::IsKindOf $elmt ArchitectureDiagram] } {
		return "CompositeStructureDiagram"
	}

	return [u2::GetMetaClassName $elmt]

};#end_proc CorrectMetaClassName
