# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportOwnedMembers { elmt headingLevel } {

  if { [catch { set containedElements [u2::GetEntities $elmt OwnedMember] } ] } { return };

  if { [llength $containedElements] == 0 } { return } ;# end_if no contained element to report

  set reported 0

  foreach element $containedElements {

    switch [u2::GetMetaClassName $element] {

      Attribute -
      Connector -
      Port -
      Association -
      Signal { continue }

    };#end_switch element metaclass name

    if { !$reported } {
        set reported 1
        html_heading $headingLevel "" "Owned members"
        html_list_start
    }

    html_bullet [GetReference $element 1]

  };#end_foreach contained element

  if { $reported } {
      html_list_end
  }

};#end_proc ReportOwnedMembers
