# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportSignals { elmt headingLevel } {

  if { [catch { set signalList [u2::GetEntities $elmt BehavioralFeature] } ] } { return }

  set signalList [FilterList $signalList "Signal"]

  if { [llength $signalList] == 0 } { return } ;# end_if no signal in element to report

  html_paragraph ""
  html_heading $headingLevel "" "Signals"

  foreach signal $signalList {

    # Create signal report heading
    html_bullet [GetReference $signal]

    html_list_start
#    ReportProperties $signal 0
    ReportParameters $signal 0
    html_list_end

  };#end_foreach signal

};#end_proc ReportSignals
