# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

proc ReportStdElement { elmt headingLevel } {

  # Section heading
  set elementMetaClassName [CorrectMetaClassName $elmt]
  set elementType [GetElementType $elmt]
  set elementName [GetElementName $elmt]

  html_heading $headingLevel "" "[ElementText $elmt]"

  incr headingLevel

  ReportComments $elmt

  ReportPresentations $elmt $headingLevel

  ReportProperties $elmt $headingLevel

  ReportParameters $elmt $headingLevel

  ReportPortInterfaces $elmt $headingLevel

  ReportAttributes $elmt $headingLevel

  ReportPorts $elmt $headingLevel

  ReportConnectors $elmt $headingLevel

  ReportSignals $elmt $headingLevel

  # Jump to inline method whenever there is one
  if { $elementMetaClassName == "State" } {

      set inlineState [u2::GetEntity $elmt InlineStateMachine]

      if { $inlineState != 0 } {
        set elmt $inlineState
      };#end_if inline state

  };#end_if element is a State

  switch $elementMetaClassName {
    Activity -
    State -
    StateMachine -
    UseCase {

      ReportConnectionPoints $elmt $headingLevel

      if { [catch { set inlineMethod [u2::GetEntity $elmt InlineMethod] } ] == 0 } {
        if { $inlineMethod != 0 } { set elmt $inlineMethod }
      };#end_if InlineMethod exists

    }

  };#end_switch element's metaclass name

  ReportStates $elmt $headingLevel

#  ReportDiagrams $elmt $headingLevel

  ReportInlineStates $elmt $headingLevel

  ReportActionNodes $elmt $headingLevel

  ReportOwnedMembers $elmt $headingLevel

  ReportSignalListSignals $elmt $headingLevel

};#end_proc ReportStdElement
