/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __ems_h
#define __ems_h

#define CUCFSetErrorCatcher(Coder, retCode) \
{ \
  retCode = setjmp((Coder)->EMS.ReturnPoint); \
  (Coder)->EMS.IsAssigned = 1; \
  if (retCode == 0) \
    { \
      (Coder)->EMS.ErrorCode = ec_SUCCESS; \
    } \
  else \
    { \
      MMSRelease(Coder); \
    } \
}



/* Error check macros */

#define NO_ARGS
#define ARGS(args) args
#define ERR_ARG(errarg) ,errarg
#define NO_ACTION

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_INNER)
#define INTERNAL_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define INTERNAL_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define INTERNAL_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define INTERNAL_ERROR_HANDLER(coder, action, errorcode, args) \
  action ;
#endif

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_MEMORY)
#define MEMORY_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define MEMORY_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define MEMORY_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define MEMORY_ERROR_HANDLER(coder, action, errorcode, args) \
  action ;
#endif

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_VALUE)
#define VALUE_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define VALUE_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define VALUE_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define VALUE_ERROR_HANDLER(coder, action, errorcode, args)
#endif

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_DECODING)
#define DECODING_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define DECODING_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define DECODING_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define DECODING_ERROR_HANDLER(coder, action, errorcode, args) \
  action ;
#endif

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_BUFFER)
#define BASEBUF_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define BASEBUF_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define BASEBUF_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define BASEBUF_ERROR_HANDLER(coder, action, errorcode, args) \
  action ;
#endif


#if defined(CODER_VMS_SDT) && !defined(CODER_REMOVE_ASCII)

#if !defined(CODER_CHECK_NONE)
#define ASCII_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args) \
  if (exp) \
    { \
      CUCFErrorOutput(stderr, errorcode args); \
      (coder)->EMS.ErrorCode = errorcode; \
      if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
      else { action ; } \
    }
#define ASCII_ERROR_HANDLER(coder, action, errorcode, args) \
  { \
    CUCFErrorOutput(stderr, errorcode args); \
    (coder)->EMS.ErrorCode = errorcode; \
    if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
    else { action ; } \
  }
#else
#define ASCII_ERROR_HANDLER_EXP(exp, coder, action, errorcode, args)
#define ASCII_ERROR_HANDLER(coder, action, errorcode, args) \
  action ;
#endif

#endif /* CODER_VMS_SDT && !CODER_REMOVE_ASCII */



/* Error messages */

#define CUCF_ERROR(errorcode, errormessage) errorcode,

enum
{
#include "ems/errors.h"
LAST_ERROR_CODE
};
#undef CUCF_ERROR

typedef int tEMSErrorCode;
typedef const char* tEMSErrorMessage;

extern const tEMSErrorMessage ErrorMessageArray[];



/* Error output configuration */

extern char* CUCFGetErrorMessage(int ErrorCode);

extern void CUCFErrorOutput(FILE *File, int ErrorCode, ...);

#ifdef CODER_EO_USER

extern void USERErrorOutputFunc(FILE* File, int ErrorCode, va_list ap);
#define EMSErrorOutputFunc(file, errorcode, ap) USERErrorOutputFunc(file, errorcode, ap)

#elif defined(CODER_EO_DEBUG)

#define EMSErrorOutputFunc(file, errorcode, ap) DebugErrorOutputFunc(file, errorcode, ap)

void DebugErrorOutputFunc(FILE* File, int ErrorCode, va_list ap);

#elif defined(CODER_EO_NONE)

#define EMSErrorOutputFunc(file, errorcode, ap)

#else /* CODER_EO_SDT */

#ifndef CODER_EO_SDT
#define CODER_EO_SDT
#endif

#include "ems/ems_eo_sdt.h"
#define EMSErrorOutputFunc(file, errorcode, ap) SDTErrorOutputFunc(errorcode, ap)

#endif

#endif /* __ems_h */

