/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __ascii_h
#define __ascii_h

#ifndef CODER_REMOVE_ASCII

#include "scttypes.h"

#define ySDL_Integer ySDL_SDL_Integer
#define ySDL_Real ySDL_SDL_Real
#define ySDL_Natural ySDL_SDL_Natural
#define ySDL_Boolean ySDL_SDL_Boolean
#define ySDL_Character ySDL_SDL_Character
#define ySDL_Time ySDL_SDL_Time
#define ySDL_Duration ySDL_SDL_Duration
#define ySDL_Pid ySDL_SDL_PId
#define ySDL_Charstring ySDL_SDL_Charstring
#define ySDL_Bit ySDL_SDL_Bit
#define ySDL_Bit_string ySDL_SDL_Bit_String
#define ySDL_Octet ySDL_SDL_Octet
#define ySDL_Octet_string ySDL_SDL_Octet_String
#define ySDL_IA5String ySDL_SDL_IA5String
#define ySDL_NumericString ySDL_SDL_NumericString
#define ySDL_PrintableString ySDL_SDL_PrintableString
#define ySDL_VisibleString ySDL_SDL_VisibleString
#define ySDL_NULL ySDL_SDL_Null
#define ySDL_Object_identifier ySDL_SDL_Object_Identifier



#define ASCII_ENCODE(c,t,v) AsciiEncode(c,t,v)
#define ASCII_DECODE(c,t,v) AsciiDecode(c,t,v)

#define ASCIIEncode(c,t,v) AsciiEncode(c,t,v)
#define ASCIIDecode(c,t,v) AsciiDecode(c,t,v)

typedef int  (*tEncodeFunc) XPP((tCoder*, tSDLTypeInfo *,void*));
typedef int  (*tDecodeFunc) XPP((tCoder*, tSDLTypeInfo *,void*));

/* Hooks for encoding of types with unknown/varying implementation (UnionC, UnserDef, ...) */
extern tEncodeFunc AsciiUserEncode;
extern tDecodeFunc AsciiUserDecode;

/* Hooks for modifying default encoding */
extern tEncodeFunc AsciiUserPreEncode;
extern tDecodeFunc AsciiUserPreDecode;

int AsciiEncode(tCoder*,tSDLTypeInfo*,void*);
int AsciiDecode(tCoder*,tSDLTypeInfo*,void*);

typedef struct tStoredRefsStruct tStoredRefs;
#ifdef XRMTDBG
/* lower-level functions are also needed */
extern void ASCIIPutByte(tCoder* Coder, unsigned char iByte);
extern unsigned char ASCIIGetByte(tCoder* Coder);
extern unsigned char ASCIIPeekByte(tCoder* Coder);
extern void AsciiEncVal(tCoder* Coder, tSDLTypeInfo* TypeNode, void* Value, tStoredRefs ** sRefs );
#endif

#endif /* !CODER_REMOVE_ASCII */

#endif  /* __ascii_h*/

